/* computer-player.c generated by valac 0.44.7, the Vala compiler
 * generated from computer-player.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define TYPE_COMPUTER_PLAYER (computer_player_get_type ())
#define COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayer))
#define COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))
#define IS_COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_PLAYER))
#define IS_COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_PLAYER))
#define COMPUTER_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))

typedef struct _ComputerPlayer ComputerPlayer;
typedef struct _ComputerPlayerClass ComputerPlayerClass;
typedef struct _ComputerPlayerPrivate ComputerPlayerPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
enum  {
	COMPUTER_PLAYER_0_PROPERTY,
	COMPUTER_PLAYER_NUM_PROPERTIES
};
static GParamSpec* computer_player_properties[COMPUTER_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _ComputerPlayerMoveAsyncData ComputerPlayerMoveAsyncData;

#define COMPUTER_PLAYER_TYPE_POSSIBLE_MOVE (computer_player_possible_move_get_type ())
typedef struct _ComputerPlayerPossibleMove ComputerPlayerPossibleMove;
#define _computer_player_possible_move_free0(var) ((var == NULL) ? NULL : (var = (computer_player_possible_move_free (var), NULL)))
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ComputerPlayer {
	GObject parent_instance;
	ComputerPlayerPrivate * priv;
};

struct _ComputerPlayerClass {
	GObjectClass parent_class;
};

struct _ComputerPlayerPrivate {
	Game* game;
	guint8 difficulty_level;
	guint pending_move_id;
	gboolean _move_pending;
	GRecMutex _move_pending_mutex;
};

struct _Block1Data {
	int _ref_count_;
	ComputerPlayer* self;
	guint8 x;
	guint8 y;
	gpointer _async_data_;
};

struct _ComputerPlayerMoveAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ComputerPlayer* self;
	gdouble delay_seconds;
	Block1Data* _data1_;
	GTimer* timer;
	GTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GTimer* _tmp3_;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GTimer* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GTimer* _tmp9_;
	GTimer* _tmp10_;
};

struct _ComputerPlayerPossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
};

static gint ComputerPlayer_private_offset;
static gpointer computer_player_parent_class = NULL;

GType computer_player_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerPlayer, g_object_unref)
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
#define COMPUTER_PLAYER_POSITIVE_INFINITY 10000
#define COMPUTER_PLAYER_NEGATIVE_INFINITY -10000
ComputerPlayer* computer_player_new (Game* game,
                                     guint8 difficulty_level);
ComputerPlayer* computer_player_construct (GType object_type,
                                           Game* game,
                                           guint8 difficulty_level);
static void computer_player_complete_move (ComputerPlayer* self,
                                    guint8 x,
                                    guint8 y);
guint8 game_place_tile (Game* self,
                        guint8 x,
                        guint8 y,
                        gboolean apply);
gchar* game_to_string (Game* self);
static void computer_player_random_select (Game* g,
                                    guint8* move_x,
                                    guint8* move_y);
void computer_player_move (ComputerPlayer* self);
static void computer_player_run_search (ComputerPlayer* self,
                                 guint8* x,
                                 guint8* y);
static void computer_player_move_async_data_free (gpointer _data);
void computer_player_move_async (ComputerPlayer* self,
                                 gdouble delay_seconds,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
void computer_player_move_finish (ComputerPlayer* self,
                                  GAsyncResult* _res_);
static gboolean computer_player_move_async_co (ComputerPlayerMoveAsyncData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean computer_player_get_move_pending (ComputerPlayer* self);
static gboolean _computer_player_move_async_co_gsource_func (gpointer self);
static void* __lambda4_ (Block1Data* _data1_);
static void computer_player_set_move_pending (ComputerPlayer* self,
                                       gboolean value);
static gpointer ___lambda4__gthread_func (gpointer self);
static gboolean __lambda5_ (Block1Data* _data1_);
static gboolean ___lambda5__gsource_func (gpointer self);
void computer_player_cancel_move (ComputerPlayer* self);
gboolean game_get_current_player_can_move (Game* self);
guint8 game_get_size (Game* self);
guint8 game_get_n_tiles (Game* self);
guint8 game_get_initial_number_of_tiles (Game* self);
Game* game_new_copy (Game* game);
Game* game_construct_copy (GType object_type,
                           Game* game);
static GType computer_player_possible_move_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static ComputerPlayerPossibleMove* computer_player_possible_move_dup (const ComputerPlayerPossibleMove* self);
static void computer_player_possible_move_free (ComputerPlayerPossibleMove* self);
static void computer_player_get_possible_moves_sorted (Game* g,
                                                GList* * moves);
static gint computer_player_search (ComputerPlayer* self,
                             Game* g,
                             gint depth,
                             gint a,
                             gint b);
void game_undo (Game* self,
                guint8 count);
static void _computer_player_possible_move_free0_ (gpointer var);
static inline void _g_list_free__computer_player_possible_move_free0_ (GList* self);
gboolean game_get_is_complete (Game* self);
guint8 game_get_n_current_tiles (Game* self);
guint8 game_get_n_opponent_tiles (Game* self);
static gint computer_player_calculate_heuristic (Game* g,
                                          guint8* difficulty_level);
void game_pass (Game* self);
static void computer_player_possible_move_init (ComputerPlayerPossibleMove *self,
                                         guint8 x,
                                         guint8 y,
                                         guint8 n_tiles);
static gint computer_player_compare_move (ComputerPlayerPossibleMove* a,
                                   ComputerPlayerPossibleMove* b);
static gint _computer_player_compare_move_gcompare_func (gconstpointer a,
                                                  gconstpointer b);
static gint computer_player_eval_heuristic (Game* g);
static gint computer_player_around (Game* g);
GType player_get_type (void) G_GNUC_CONST;
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
Player game_get_current_color (Game* self);
static gint computer_player_is_empty (Game* g,
                               gint8 x,
                               gint8 y);
gboolean game_is_valid_location_signed (Game* self,
                                        gint8 x,
                                        gint8 y);
gboolean game_can_place (Game* self,
                         guint8 x,
                         guint8 y,
                         Player color);
static void computer_player_finalize (GObject * obj);
static void _vala_computer_player_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_computer_player_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

static const gint COMPUTER_PLAYER_heuristic[64] = {65, -3, 6, 4, 4, 6, -3, 65, -3, -29, 3, 1, 1, 3, -29, -3, 6, 3, 5, 3, 3, 5, 3, 6, 4, 1, 3, 1, 1, 3, 1, 4, 4, 1, 3, 1, 1, 3, 1, 4, 6, 3, 5, 3, 3, 5, 3, 6, -3, -29, 3, 1, 1, 3, -29, -3, 65, -3, 6, 4, 4, 6, -3, 65};

static inline gpointer
computer_player_get_instance_private (ComputerPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, ComputerPlayer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

ComputerPlayer*
computer_player_construct (GType object_type,
                           Game* game,
                           guint8 difficulty_level)
{
	ComputerPlayer * self = NULL;
	Game* _tmp0_;
	g_return_val_if_fail (game != NULL, NULL);
	self = (ComputerPlayer*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (game);
	_g_object_unref0 (self->priv->game);
	self->priv->game = _tmp0_;
	self->priv->difficulty_level = difficulty_level;
	return self;
}

ComputerPlayer*
computer_player_new (Game* game,
                     guint8 difficulty_level)
{
	return computer_player_construct (TYPE_COMPUTER_PLAYER, game, difficulty_level);
}

static void
computer_player_complete_move (ComputerPlayer* self,
                               guint8 x,
                               guint8 y)
{
	Game* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	if (((gint) game_place_tile (_tmp0_, x, y, TRUE)) == 0) {
		Game* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		guint8 new_x = 0U;
		guint8 new_y = 0U;
		Game* _tmp4_;
		guint8 _tmp5_ = 0U;
		guint8 _tmp6_ = 0U;
		Game* _tmp7_;
		_tmp1_ = self->priv->game;
		_tmp2_ = game_to_string (_tmp1_);
		_tmp3_ = _tmp2_;
		g_critical ("computer-player.vala:97: Computer chose an invalid move: %d,%d\n%s", (gint) x, (gint) y, _tmp3_);
		_g_free0 (_tmp3_);
		_tmp4_ = self->priv->game;
		computer_player_random_select (_tmp4_, &_tmp5_, &_tmp6_);
		new_x = _tmp5_;
		new_y = _tmp6_;
		_tmp7_ = self->priv->game;
		if (((gint) game_place_tile (_tmp7_, new_x, new_y, TRUE)) == 0) {
			Game* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp8_ = self->priv->game;
			_tmp9_ = game_to_string (_tmp8_);
			_tmp10_ = _tmp9_;
			g_critical ("computer-player.vala:105: Computer chose an invalid move for the secon" \
"d time: %d,%d\n" \
"%s", (gint) new_x, (gint) new_y, _tmp10_);
			_g_free0 (_tmp10_);
			g_assert_not_reached ();
		}
	}
}

void
computer_player_move (ComputerPlayer* self)
{
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	g_return_if_fail (self != NULL);
	computer_player_run_search (self, &_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	computer_player_complete_move (self, x, y);
}

static void
computer_player_move_async_data_free (gpointer _data)
{
	ComputerPlayerMoveAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (ComputerPlayerMoveAsyncData, _data_);
}

void
computer_player_move_async (ComputerPlayer* self,
                            gdouble delay_seconds,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	ComputerPlayerMoveAsyncData* _data_;
	ComputerPlayer* _tmp0_;
	_data_ = g_slice_new0 (ComputerPlayerMoveAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, computer_player_move_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->delay_seconds = delay_seconds;
	computer_player_move_async_co (_data_);
}

void
computer_player_move_finish (ComputerPlayer* self,
                             GAsyncResult* _res_)
{
	ComputerPlayerMoveAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		ComputerPlayer* self;
		self = _data1_->self;
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gboolean
_computer_player_move_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = computer_player_move_async_co (self);
	return result;
}

static void*
__lambda4_ (Block1Data* _data1_)
{
	ComputerPlayer* self;
	void* result = NULL;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	self = _data1_->self;
	computer_player_set_move_pending (self, TRUE);
	computer_player_run_search (self, &_tmp0_, &_tmp1_);
	_data1_->x = _tmp0_;
	_data1_->y = _tmp1_;
	computer_player_move_async_co (_data1_->_async_data_);
	result = NULL;
	return result;
}

static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda4_ (self);
	block1_data_unref (self);
	return result;
}

static gboolean
__lambda5_ (Block1Data* _data1_)
{
	ComputerPlayer* self;
	gboolean result = FALSE;
	self = _data1_->self;
	computer_player_complete_move (self, _data1_->x, _data1_->y);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ (self);
	return result;
}

static gboolean
computer_player_move_async_co (ComputerPlayerMoveAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data1_ = g_slice_new0 (Block1Data);
	_data_->_data1_->_ref_count_ = 1;
	_data_->_data1_->self = g_object_ref (_data_->self);
	_data_->_data1_->_async_data_ = _data_;
	_data_->_tmp0_ = g_timer_new ();
	_data_->timer = _data_->_tmp0_;
	_data_->_data1_->x = (guint8) 0;
	_data_->_data1_->y = (guint8) 0;
	while (TRUE) {
		_data_->_tmp1_ = computer_player_get_move_pending (_data_->self);
		_data_->_tmp2_ = _data_->_tmp1_;
		if (!_data_->_tmp2_) {
			break;
		}
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _computer_player_move_async_co_gsource_func, _data_, NULL);
		_data_->_state_ = 1;
		return FALSE;
		_state_1:
		;
	}
	_data_->_tmp3_ = _data_->timer;
	g_timer_start (_data_->_tmp3_);
	_data_->_tmp4_ = g_thread_new ("AI thread", ___lambda4__gthread_func, block1_data_ref (_data_->_data1_));
	_data_->_tmp5_ = _data_->_tmp4_;
	_g_thread_unref0 (_data_->_tmp5_);
	_data_->_state_ = 2;
	return FALSE;
	_state_2:
	;
	_data_->_tmp6_ = _data_->timer;
	g_timer_stop (_data_->_tmp6_);
	_data_->_tmp7_ = computer_player_get_move_pending (_data_->self);
	_data_->_tmp8_ = _data_->_tmp7_;
	if (!_data_->_tmp8_) {
		_g_timer_destroy0 (_data_->timer);
		block1_data_unref (_data_->_data1_);
		_data_->_data1_ = NULL;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp9_ = _data_->timer;
	if (g_timer_elapsed (_data_->_tmp9_, NULL) < _data_->delay_seconds) {
		_data_->_tmp10_ = _data_->timer;
		_data_->self->priv->pending_move_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) ((_data_->delay_seconds - g_timer_elapsed (_data_->_tmp10_, NULL)) * 1000), _computer_player_move_async_co_gsource_func, _data_, NULL);
		_data_->_state_ = 3;
		return FALSE;
		_state_3:
		;
	}
	_data_->self->priv->pending_move_id = (guint) 0;
	computer_player_set_move_pending (_data_->self, FALSE);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda5__gsource_func, block1_data_ref (_data_->_data1_), block1_data_unref);
	_g_timer_destroy0 (_data_->timer);
	block1_data_unref (_data_->_data1_);
	_data_->_data1_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

void
computer_player_cancel_move (ComputerPlayer* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = computer_player_get_move_pending (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	if (self->priv->pending_move_id != ((guint) 0)) {
		g_source_remove (self->priv->pending_move_id);
		self->priv->pending_move_id = (guint) 0;
	}
	computer_player_set_move_pending (self, FALSE);
}

static gpointer
_computer_player_possible_move_dup0 (gpointer self)
{
	return self ? computer_player_possible_move_dup (self) : NULL;
}

static void
_computer_player_possible_move_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (computer_player_possible_move_free (var), NULL));
}

static inline void
_g_list_free__computer_player_possible_move_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _computer_player_possible_move_free0_);
}

static void
computer_player_run_search (ComputerPlayer* self,
                            guint8* x,
                            guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
	Game* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_ = 0;
	Game* _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	Game* _tmp7_;
	guint8 _tmp8_;
	guint8 _tmp9_;
	Game* _tmp10_;
	guint8 _tmp11_;
	guint8 _tmp12_;
	Game* g = NULL;
	Game* _tmp16_;
	Game* _tmp17_;
	gint depth = 0;
	gint a = 0;
	GList* moves = NULL;
	Game* _tmp18_;
	GList* _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = game_get_current_player_can_move (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_return_if_fail (_tmp2_, "game.current_player_can_move");
	_tmp4_ = self->priv->game;
	_tmp5_ = game_get_size (_tmp4_);
	_tmp6_ = _tmp5_;
	if (((gint) _tmp6_) < 6) {
		_tmp3_ = 2;
	} else {
		_tmp3_ = 4;
	}
	_tmp7_ = self->priv->game;
	_tmp8_ = game_get_n_tiles (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = self->priv->game;
	_tmp11_ = game_get_initial_number_of_tiles (_tmp10_);
	_tmp12_ = _tmp11_;
	if (((gint) _tmp9_) < (_tmp12_ + _tmp3_)) {
		Game* _tmp13_;
		guint8 _tmp14_ = 0U;
		guint8 _tmp15_ = 0U;
		_tmp13_ = self->priv->game;
		computer_player_random_select (_tmp13_, &_tmp14_, &_tmp15_);
		_vala_x = _tmp14_;
		_vala_y = _tmp15_;
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		return;
	}
	_vala_x = (guint8) 0;
	_vala_y = (guint8) 0;
	_tmp16_ = self->priv->game;
	_tmp17_ = game_new_copy (_tmp16_);
	g = _tmp17_;
	depth = self->priv->difficulty_level * 2;
	a = COMPUTER_PLAYER_NEGATIVE_INFINITY - 1;
	moves = NULL;
	_tmp18_ = g;
	computer_player_get_possible_moves_sorted (_tmp18_, &moves);
	_tmp19_ = moves;
	{
		GList* move_collection = NULL;
		GList* move_it = NULL;
		move_collection = _tmp19_;
		for (move_it = move_collection; move_it != NULL; move_it = move_it->next) {
			ComputerPlayerPossibleMove* _tmp20_;
			ComputerPlayerPossibleMove* move = NULL;
			_tmp20_ = _computer_player_possible_move_dup0 ((ComputerPlayerPossibleMove*) move_it->data);
			move = _tmp20_;
			{
				ComputerPlayerPossibleMove* _tmp21_;
				Game* _tmp22_;
				ComputerPlayerPossibleMove* _tmp23_;
				ComputerPlayerPossibleMove* _tmp24_;
				gint a_new = 0;
				Game* _tmp31_;
				Game* _tmp34_;
				_tmp21_ = move;
				if (_tmp21_ == NULL) {
					g_assert_not_reached ();
				}
				_tmp22_ = g;
				_tmp23_ = move;
				_tmp24_ = move;
				if (((gint) game_place_tile (_tmp22_, ((ComputerPlayerPossibleMove) (*_tmp23_)).x, ((ComputerPlayerPossibleMove) (*_tmp24_)).y, TRUE)) == 0) {
					ComputerPlayerPossibleMove* _tmp25_;
					ComputerPlayerPossibleMove* _tmp26_;
					ComputerPlayerPossibleMove* _tmp27_;
					Game* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					_tmp25_ = move;
					_tmp26_ = move;
					_tmp27_ = move;
					_tmp28_ = g;
					_tmp29_ = game_to_string (_tmp28_);
					_tmp30_ = _tmp29_;
					g_critical ("computer-player.vala:218: Computer marked move (depth %d, %d,%d, %d fl" \
"ips) as valid, but is invalid when checking.\n" \
"%s", depth, (gint) ((ComputerPlayerPossibleMove) (*_tmp25_)).x, (gint) ((ComputerPlayerPossibleMove) (*_tmp26_)).y, (gint) ((ComputerPlayerPossibleMove) (*_tmp27_)).n_tiles, _tmp30_);
					_g_free0 (_tmp30_);
					g_assert_not_reached ();
				}
				_tmp31_ = g;
				a_new = -1 * computer_player_search (self, _tmp31_, depth, COMPUTER_PLAYER_NEGATIVE_INFINITY, -a);
				if (a_new > a) {
					ComputerPlayerPossibleMove* _tmp32_;
					ComputerPlayerPossibleMove* _tmp33_;
					a = a_new;
					_tmp32_ = move;
					_vala_x = ((ComputerPlayerPossibleMove) (*_tmp32_)).x;
					_tmp33_ = move;
					_vala_y = ((ComputerPlayerPossibleMove) (*_tmp33_)).y;
				}
				_tmp34_ = g;
				game_undo (_tmp34_, (guint8) 1);
				_computer_player_possible_move_free0 (move);
			}
		}
	}
	(moves == NULL) ? NULL : (moves = (_g_list_free__computer_player_possible_move_free0_ (moves), NULL));
	_g_object_unref0 (g);
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}

static gint
computer_player_search (ComputerPlayer* self,
                        Game* g,
                        gint depth,
                        gint a,
                        gint b)
{
	gint result = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (g != NULL, 0);
	_vala_return_val_if_fail (a <= b, "a <= b", 0);
	_tmp0_ = game_get_is_complete (g);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gint _tmp2_ = 0;
		guint8 _tmp3_;
		guint8 _tmp4_;
		guint8 _tmp5_;
		guint8 _tmp6_;
		_tmp3_ = game_get_n_current_tiles (g);
		_tmp4_ = _tmp3_;
		_tmp5_ = game_get_n_opponent_tiles (g);
		_tmp6_ = _tmp5_;
		if (_tmp4_ > _tmp6_) {
			guint8 _tmp7_;
			guint8 _tmp8_;
			_tmp7_ = game_get_n_opponent_tiles (g);
			_tmp8_ = _tmp7_;
			_tmp2_ = COMPUTER_PLAYER_POSITIVE_INFINITY - _tmp8_;
		} else {
			guint8 _tmp9_;
			guint8 _tmp10_;
			_tmp9_ = game_get_n_current_tiles (g);
			_tmp10_ = _tmp9_;
			_tmp2_ = COMPUTER_PLAYER_NEGATIVE_INFINITY + _tmp10_;
		}
		result = _tmp2_;
		return result;
	}
	_tmp11_ = computer_player_get_move_pending (self);
	_tmp12_ = _tmp11_;
	if (!_tmp12_) {
		result = 0;
		return result;
	}
	if (depth == 0) {
		gint _tmp13_;
		_tmp13_ = computer_player_calculate_heuristic (g, &self->priv->difficulty_level);
		result = _tmp13_;
		return result;
	}
	_tmp14_ = game_get_current_player_can_move (g);
	_tmp15_ = _tmp14_;
	if (_tmp15_) {
		GList* moves = NULL;
		GList* _tmp16_;
		moves = NULL;
		computer_player_get_possible_moves_sorted (g, &moves);
		_tmp16_ = moves;
		{
			GList* move_collection = NULL;
			GList* move_it = NULL;
			move_collection = _tmp16_;
			for (move_it = move_collection; move_it != NULL; move_it = move_it->next) {
				ComputerPlayerPossibleMove* _tmp17_;
				ComputerPlayerPossibleMove* move = NULL;
				_tmp17_ = _computer_player_possible_move_dup0 ((ComputerPlayerPossibleMove*) move_it->data);
				move = _tmp17_;
				{
					ComputerPlayerPossibleMove* _tmp18_;
					ComputerPlayerPossibleMove* _tmp19_;
					ComputerPlayerPossibleMove* _tmp20_;
					gint a_new = 0;
					_tmp18_ = move;
					if (_tmp18_ == NULL) {
						g_assert_not_reached ();
					}
					_tmp19_ = move;
					_tmp20_ = move;
					if (((gint) game_place_tile (g, ((ComputerPlayerPossibleMove) (*_tmp19_)).x, ((ComputerPlayerPossibleMove) (*_tmp20_)).y, TRUE)) == 0) {
						ComputerPlayerPossibleMove* _tmp21_;
						ComputerPlayerPossibleMove* _tmp22_;
						ComputerPlayerPossibleMove* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						_tmp21_ = move;
						_tmp22_ = move;
						_tmp23_ = move;
						_tmp24_ = game_to_string (g);
						_tmp25_ = _tmp24_;
						g_critical ("computer-player.vala:263: Computer marked move (depth %d, %d,%d, %d fl" \
"ips) as valid, but is invalid when checking.\n" \
"%s", depth, (gint) ((ComputerPlayerPossibleMove) (*_tmp21_)).x, (gint) ((ComputerPlayerPossibleMove) (*_tmp22_)).y, (gint) ((ComputerPlayerPossibleMove) (*_tmp23_)).n_tiles, _tmp25_);
						_g_free0 (_tmp25_);
						g_assert_not_reached ();
					}
					a_new = -1 * computer_player_search (self, g, depth - 1, -b, -a);
					if (a_new > a) {
						a = a_new;
					}
					game_undo (g, (guint8) 1);
					if (b <= a) {
						_computer_player_possible_move_free0 (move);
						break;
					}
					_computer_player_possible_move_free0 (move);
				}
			}
		}
		(moves == NULL) ? NULL : (moves = (_g_list_free__computer_player_possible_move_free0_ (moves), NULL));
	} else {
		gint a_new = 0;
		game_pass (g);
		a_new = -1 * computer_player_search (self, g, depth - 1, -b, -a);
		if (a_new > a) {
			a = a_new;
		}
		game_undo (g, (guint8) 1);
	}
	result = a;
	return result;
}

static gint
_computer_player_compare_move_gcompare_func (gconstpointer a,
                                             gconstpointer b)
{
	gint result;
	result = computer_player_compare_move ((ComputerPlayerPossibleMove*) a, (ComputerPlayerPossibleMove*) b);
	return result;
}

static void
computer_player_get_possible_moves_sorted (Game* g,
                                           GList* * moves)
{
	g_return_if_fail (g != NULL);
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint8 _tmp2_;
				guint8 _tmp3_;
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = game_get_size (g);
				_tmp3_ = _tmp2_;
				if (!(x < _tmp3_)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint8 _tmp6_;
							guint8 _tmp7_;
							guint8 n_tiles = 0U;
							ComputerPlayerPossibleMove move = {0};
							ComputerPlayerPossibleMove _tmp8_;
							ComputerPlayerPossibleMove* _tmp9_;
							if (!_tmp4_) {
								guint8 _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = game_get_size (g);
							_tmp7_ = _tmp6_;
							if (!(y < _tmp7_)) {
								break;
							}
							n_tiles = game_place_tile (g, x, y, FALSE);
							if (((gint) n_tiles) == 0) {
								continue;
							}
							computer_player_possible_move_init (&move, x, y, n_tiles);
							_tmp8_ = move;
							_tmp9_ = _computer_player_possible_move_dup0 (&_tmp8_);
							*moves = g_list_insert_sorted (*moves, _tmp9_, _computer_player_compare_move_gcompare_func);
						}
					}
				}
			}
		}
	}
}

static gint
computer_player_compare_move (ComputerPlayerPossibleMove* a,
                              ComputerPlayerPossibleMove* b)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	if (a == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = b == NULL;
	}
	if (_tmp0_) {
		g_assert_not_reached ();
	}
	result = (gint) (((ComputerPlayerPossibleMove) (*b)).n_tiles - ((ComputerPlayerPossibleMove) (*a)).n_tiles);
	return result;
}

static gint
computer_player_calculate_heuristic (Game* g,
                                     guint8* difficulty_level)
{
	gint result = 0;
	gint tile_difference = 0;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	g_return_val_if_fail (g != NULL, 0);
	_tmp0_ = game_get_n_current_tiles (g);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_n_opponent_tiles (g);
	_tmp3_ = _tmp2_;
	tile_difference = (gint) (_tmp1_ - _tmp3_);
	if (((gint) (*difficulty_level)) == 1) {
		result = -tile_difference;
		return result;
	}
	_tmp4_ = game_get_n_tiles (g);
	_tmp5_ = _tmp4_;
	if (((gint) _tmp5_) >= 54) {
		result = tile_difference;
		return result;
	}
	result = (tile_difference + computer_player_eval_heuristic (g)) + computer_player_around (g);
	return result;
}

static gint
computer_player_eval_heuristic (Game* g)
{
	gint result = 0;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint count = 0;
	g_return_val_if_fail (g != NULL, 0);
	_tmp0_ = game_get_size (g);
	_tmp1_ = _tmp0_;
	if (((gint) _tmp1_) != 8) {
		result = 0;
		return result;
	}
	count = 0;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				guint8 _tmp4_;
				guint8 _tmp5_;
				if (!_tmp2_) {
					guint8 _tmp3_;
					_tmp3_ = x;
					x = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = game_get_size (g);
				_tmp5_ = _tmp4_;
				if (!(x < _tmp5_)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							guint8 _tmp8_;
							guint8 _tmp9_;
							gint h = 0;
							guint8 _tmp10_;
							guint8 _tmp11_;
							gint _tmp12_;
							Player _tmp13_;
							Player _tmp14_;
							if (!_tmp6_) {
								guint8 _tmp7_;
								_tmp7_ = y;
								y = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = game_get_size (g);
							_tmp9_ = _tmp8_;
							if (!(y < _tmp9_)) {
								break;
							}
							_tmp10_ = game_get_size (g);
							_tmp11_ = _tmp10_;
							_tmp12_ = COMPUTER_PLAYER_heuristic[(y * _tmp11_) + x];
							h = _tmp12_;
							_tmp13_ = game_get_current_color (g);
							_tmp14_ = _tmp13_;
							if (game_get_owner (g, x, y) != _tmp14_) {
								h = -h;
							}
							count = count + h;
						}
					}
				}
			}
		}
	}
	result = count;
	return result;
}

static gint
computer_player_around (Game* g)
{
	gint result = 0;
	gint count = 0;
	g_return_val_if_fail (g != NULL, 0);
	count = 0;
	{
		gint8 x = 0;
		x = (gint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint8 _tmp2_;
				guint8 _tmp3_;
				if (!_tmp0_) {
					gint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = game_get_size (g);
				_tmp3_ = _tmp2_;
				if (!(x < ((gint8) _tmp3_))) {
					break;
				}
				{
					gint8 y = 0;
					y = (gint8) 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint8 _tmp6_;
							guint8 _tmp7_;
							gint a = 0;
							gint _tmp8_ = 0;
							Player _tmp9_;
							Player _tmp10_;
							if (!_tmp4_) {
								gint8 _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = game_get_size (g);
							_tmp7_ = _tmp6_;
							if (!(y < ((gint8) _tmp7_))) {
								break;
							}
							a = 0;
							a = a - computer_player_is_empty (g, (gint8) (x + 1), y);
							a = a - computer_player_is_empty (g, (gint8) (x + 1), (gint8) (y + 1));
							a = a - computer_player_is_empty (g, x, (gint8) (y + 1));
							a = a - computer_player_is_empty (g, (gint8) (x - 1), (gint8) (y + 1));
							a = a - computer_player_is_empty (g, (gint8) (x - 1), y);
							a = a - computer_player_is_empty (g, (gint8) (x - 1), (gint8) (y - 1));
							a = a - computer_player_is_empty (g, x, (gint8) (y - 1));
							a = a - computer_player_is_empty (g, (gint8) (x + 1), (gint8) (y - 1));
							if (a == 0) {
								a = 2;
							}
							_tmp9_ = game_get_current_color (g);
							_tmp10_ = _tmp9_;
							if (game_get_owner (g, (guint8) x, (guint8) y) == _tmp10_) {
								_tmp8_ = a;
							} else {
								_tmp8_ = -a;
							}
							count = count + _tmp8_;
						}
					}
				}
			}
		}
	}
	result = count;
	return result;
}

static gint
computer_player_is_empty (Game* g,
                          gint8 x,
                          gint8 y)
{
	gint result = 0;
	g_return_val_if_fail (g != NULL, 0);
	if (!game_is_valid_location_signed (g, x, y)) {
		result = 0;
		return result;
	}
	if (game_get_owner (g, (guint8) x, (guint8) y) != PLAYER_NONE) {
		result = 0;
		return result;
	}
	result = 1;
	return result;
}

static void
computer_player_random_select (Game* g,
                               guint8* move_x,
                               guint8* move_y)
{
	guint8 _vala_move_x = 0U;
	guint8 _vala_move_y = 0U;
	GList* moves = NULL;
	gint length = 0;
	GList* _tmp12_;
	guint8 i = 0U;
	guint8 xy = 0U;
	GList* _tmp13_;
	gconstpointer _tmp14_;
	guint8 _tmp15_;
	guint8 _tmp16_;
	guint8 _tmp17_;
	guint8 _tmp18_;
	g_return_if_fail (g != NULL);
	moves = NULL;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint8 _tmp2_;
				guint8 _tmp3_;
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = game_get_size (g);
				_tmp3_ = _tmp2_;
				if (!(x < _tmp3_)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint8 _tmp6_;
							guint8 _tmp7_;
							Player _tmp8_;
							Player _tmp9_;
							if (!_tmp4_) {
								guint8 _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = game_get_size (g);
							_tmp7_ = _tmp6_;
							if (!(y < _tmp7_)) {
								break;
							}
							_tmp8_ = game_get_current_color (g);
							_tmp9_ = _tmp8_;
							if (game_can_place (g, x, y, _tmp9_)) {
								guint8 _tmp10_;
								guint8 _tmp11_;
								_tmp10_ = game_get_size (g);
								_tmp11_ = _tmp10_;
								moves = g_list_append (moves, (gpointer) ((guintptr) ((x * _tmp11_) + y)));
							}
						}
					}
				}
			}
		}
	}
	_tmp12_ = moves;
	length = (gint) g_list_length (_tmp12_);
	if (length == 0) {
		g_assert_not_reached ();
	}
	i = (guint8) g_random_int_range ((gint32) 0, (gint32) length);
	_tmp13_ = moves;
	_tmp14_ = g_list_nth_data (_tmp13_, (guint) i);
	xy = (guint8) ((guintptr) _tmp14_);
	_tmp15_ = game_get_size (g);
	_tmp16_ = _tmp15_;
	_vala_move_x = xy / _tmp16_;
	_tmp17_ = game_get_size (g);
	_tmp18_ = _tmp17_;
	_vala_move_y = xy % _tmp18_;
	(moves == NULL) ? NULL : (moves = (g_list_free (moves), NULL));
	if (move_x) {
		*move_x = _vala_move_x;
	}
	if (move_y) {
		*move_y = _vala_move_y;
	}
}

static gboolean
computer_player_get_move_pending (ComputerPlayer* self)
{
	gboolean result;
	gboolean _result_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_rec_mutex_lock (&self->priv->_move_pending_mutex);
	_result_ = self->priv->_move_pending;
	g_rec_mutex_unlock (&self->priv->_move_pending_mutex);
	result = _result_;
	return result;
}

static void
computer_player_set_move_pending (ComputerPlayer* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	g_rec_mutex_lock (&self->priv->_move_pending_mutex);
	self->priv->_move_pending = value;
	g_rec_mutex_unlock (&self->priv->_move_pending_mutex);
}

static void
computer_player_possible_move_init (ComputerPlayerPossibleMove *self,
                                    guint8 x,
                                    guint8 y,
                                    guint8 n_tiles)
{
	memset (self, 0, sizeof (ComputerPlayerPossibleMove));
	(*self).x = x;
	(*self).y = y;
	(*self).n_tiles = n_tiles;
}

static ComputerPlayerPossibleMove*
computer_player_possible_move_dup (const ComputerPlayerPossibleMove* self)
{
	ComputerPlayerPossibleMove* dup;
	dup = g_new0 (ComputerPlayerPossibleMove, 1);
	memcpy (dup, self, sizeof (ComputerPlayerPossibleMove));
	return dup;
}

static void
computer_player_possible_move_free (ComputerPlayerPossibleMove* self)
{
	g_free (self);
}

static GType
computer_player_possible_move_get_type (void)
{
	static volatile gsize computer_player_possible_move_type_id__volatile = 0;
	if (g_once_init_enter (&computer_player_possible_move_type_id__volatile)) {
		GType computer_player_possible_move_type_id;
		computer_player_possible_move_type_id = g_boxed_type_register_static ("ComputerPlayerPossibleMove", (GBoxedCopyFunc) computer_player_possible_move_dup, (GBoxedFreeFunc) computer_player_possible_move_free);
		g_once_init_leave (&computer_player_possible_move_type_id__volatile, computer_player_possible_move_type_id);
	}
	return computer_player_possible_move_type_id__volatile;
}

static void
computer_player_class_init (ComputerPlayerClass * klass,
                            gpointer klass_data)
{
	computer_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ComputerPlayer_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_computer_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_computer_player_set_property;
	G_OBJECT_CLASS (klass)->finalize = computer_player_finalize;
}

static void
computer_player_instance_init (ComputerPlayer * self,
                               gpointer klass)
{
	self->priv = computer_player_get_instance_private (self);
	self->priv->pending_move_id = (guint) 0;
	self->priv->_move_pending = FALSE;
}

static void
computer_player_finalize (GObject * obj)
{
	ComputerPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPUTER_PLAYER, ComputerPlayer);
	_g_object_unref0 (self->priv->game);
	_vala_clear_GRecMutex (&self->priv->_move_pending_mutex);
	G_OBJECT_CLASS (computer_player_parent_class)->finalize (obj);
}

GType
computer_player_get_type (void)
{
	static volatile gsize computer_player_type_id__volatile = 0;
	if (g_once_init_enter (&computer_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ComputerPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) computer_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComputerPlayer), 0, (GInstanceInitFunc) computer_player_instance_init, NULL };
		GType computer_player_type_id;
		computer_player_type_id = g_type_register_static (G_TYPE_OBJECT, "ComputerPlayer", &g_define_type_info, 0);
		ComputerPlayer_private_offset = g_type_add_instance_private (computer_player_type_id, sizeof (ComputerPlayerPrivate));
		g_once_init_leave (&computer_player_type_id__volatile, computer_player_type_id);
	}
	return computer_player_type_id__volatile;
}

static void
_vala_computer_player_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ComputerPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_PLAYER, ComputerPlayer);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_computer_player_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ComputerPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_PLAYER, ComputerPlayer);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

