/* game-view.c generated by valac 0.44.7, the Vala compiler
 * generated from game-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <librsvg/rsvg.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;
typedef struct _GameViewPrivate GameViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	GAME_VIEW_0_PROPERTY,
	GAME_VIEW_SCOREBOARD_PROPERTY,
	GAME_VIEW_SOUND_FLIP_PROPERTY,
	GAME_VIEW_SOUND_GAMEOVER_PROPERTY,
	GAME_VIEW_GAME_PROPERTY,
	GAME_VIEW_THEME_PROPERTY,
	GAME_VIEW_NUM_PROPERTIES
};
static GParamSpec* game_view_properties[GAME_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
enum  {
	GAME_VIEW_MOVE_SIGNAL,
	GAME_VIEW_NUM_SIGNALS
};
static guint game_view_signals[GAME_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GameView {
	GtkDrawingArea parent_instance;
	GameViewPrivate * priv;
};

struct _GameViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _GameViewPrivate {
	GtkDrawingArea* _scoreboard;
	gchar* pieces_file;
	gdouble background_red;
	gdouble background_green;
	gdouble background_blue;
	gint background_radius;
	gdouble mark_red;
	gdouble mark_green;
	gdouble mark_blue;
	gint mark_width;
	gdouble border_red;
	gdouble border_green;
	gdouble border_blue;
	gint border_width;
	gdouble spacing_red;
	gdouble spacing_green;
	gdouble spacing_blue;
	gint spacing_width;
	gdouble highlight_red;
	gdouble highlight_green;
	gdouble highlight_blue;
	gdouble highlight_alpha;
	gchar* _sound_flip;
	gchar* _sound_gameover;
	gboolean show_highlight;
	gboolean highlight_set;
	guint8 highlight_x;
	guint8 highlight_y;
	guint8 highlight_state;
	guint render_size;
	cairo_pattern_t* tiles_pattern;
	cairo_pattern_t* scoreboard_tiles_pattern;
	gint* pixmaps;
	gint pixmaps_length1;
	gint pixmaps_length2;
	guint animate_timeout;
	gint current_player_number;
	gboolean game_is_set;
	guint8 game_size;
	Game* _game;
	gchar* _theme;
	gint paving_size;
	gint tile_size;
	gint board_size;
	gboolean flip_final_result_now;
	Player winning_color;
	gint n_winning_tiles;
	Player losing_color;
	gint n_losing_tiles;
};

struct _Block2Data {
	int _ref_count_;
	GameView* self;
	gboolean is_final_animation;
};

static gint GameView_private_offset;
static gpointer game_view_parent_class = NULL;

GType game_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameView, g_object_unref)
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
GType player_get_type (void) G_GNUC_CONST;
#define GAME_VIEW_HIGHLIGHT_MAX ((guint8) 5)
#define GAME_VIEW_PIXMAP_FLIP_DELAY 20
#define GAME_VIEW_HALF_PI (G_PI / 2.0)
static void game_view_set_default_theme (GameView* self,
                                  GKeyFile* * key);
static void game_view_load_theme (GameView* self,
                           GKeyFile* key);
static void game_view_set_sound_flip (GameView* self,
                               const gchar* value);
static void game_view_set_sound_gameover (GameView* self,
                                   const gchar* value);
static void game_view_calculate (GameView* self);
static gboolean game_view_real_draw (GtkWidget* base,
                              cairo_t* cr);
static void game_view_load_image (GameView* self,
                           cairo_t* c,
                           gint width,
                           gint height);
static gint game_view_get_board_x (GameView* self);
static gint game_view_get_board_y (GameView* self);
static void game_view_rounded_square (GameView* self,
                               cairo_t* cr,
                               gdouble x,
                               gdouble y,
                               gint size,
                               gdouble width,
                               gdouble radius_percent);
Game* game_view_get_game (GameView* self);
gboolean game_get_is_complete (Game* self);
static void game_view_square_changed_cb (GameView* self,
                                  guint8 x,
                                  guint8 y,
                                  Player replacement);
static void game_view_set_square (GameView* self,
                           guint8 x,
                           guint8 y,
                           gint pixmap,
                           gboolean is_final_animation,
                           gboolean force_redraw);
static gint game_view_get_pixmap (Player color);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
static inline void game_view_update_square (GameView* self,
                              guint8 x,
                              guint8 y);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ____lambda7_ (Block2Data* _data2_);
static void game_view_flip_final_result_tile (GameView* self,
                                       guint8 x,
                                       guint8 y);
static gboolean _____lambda7__gsource_func (gpointer self);
static void game_view_game_is_complete_cb (GameView* self);
guint8 game_get_n_light_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
static gboolean __lambda6_ (GameView* self);
static void game_view_set_winner_and_loser_variables (GameView* self);
static gboolean ___lambda6__gsource_func (gpointer self);
gboolean game_view_undo_final_animation (GameView* self);
static gboolean game_view_real_button_press_event (GtkWidget* base,
                                            GdkEventButton* event);
gboolean game_is_valid_location_signed (Game* self,
                                        gint8 x,
                                        gint8 y);
static gboolean game_view_real_key_press_event (GtkWidget* base,
                                         GdkEventKey* event);
Player game_get_current_color (Game* self);
static gboolean game_view_draw_scoreboard (GameView* self,
                                    cairo_t* cr);
static GtkDrawingArea* game_view_get_scoreboard (GameView* self);
void game_view_update_scoreboard (GameView* self);
GameView* game_view_new (void);
GameView* game_view_construct (GType object_type);
void game_view_set_scoreboard (GameView* self,
                               GtkDrawingArea* value);
static gboolean _game_view_draw_scoreboard_gtk_widget_draw (GtkWidget* _sender,
                                                     cairo_t* cr,
                                                     gpointer self);
const gchar* game_view_get_sound_flip (GameView* self);
const gchar* game_view_get_sound_gameover (GameView* self);
void game_view_set_game (GameView* self,
                         Game* value);
guint8 game_get_size (Game* self);
static void _game_view_game_is_complete_cb_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _game_view_square_changed_cb_game_square_changed (Game* _sender,
                                                       guint8 x,
                                                       guint8 y,
                                                       Player new_color,
                                                       gpointer self);
gboolean game_get_alternative_start (Game* self);
const gchar* game_view_get_theme (GameView* self);
void game_view_set_theme (GameView* self,
                          const gchar* value);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * game_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void game_view_finalize (GObject * obj);
static void _vala_game_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_game_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
game_view_get_instance_private (GameView* self)
{
	return G_STRUCT_MEMBER_P (self, GameView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
game_view_set_default_theme (GameView* self,
                             GKeyFile* * key)
{
	GtkSettings* defaults = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* filename = NULL;
	gboolean _tmp2_ = FALSE;
	GtkSettings* _tmp3_;
	gchar* filepath = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (*key != NULL);
	_tmp0_ = gtk_settings_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	defaults = _tmp1_;
	_tmp3_ = defaults;
	if (_tmp3_ != NULL) {
		GtkSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp4_ = defaults;
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp5_, NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = _tmp6_;
		_tmp2_ = string_contains (_tmp7_, "HighContrast");
		_g_free0 (_tmp7_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gchar* _tmp8_;
		_tmp8_ = g_strdup ("high_contrast.theme");
		_g_free0 (filename);
		filename = _tmp8_;
	} else {
		gboolean _tmp9_ = FALSE;
		GtkSettings* _tmp10_;
		_tmp10_ = defaults;
		if (_tmp10_ != NULL) {
			gboolean _tmp11_ = FALSE;
			GtkSettings* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
			_tmp12_ = defaults;
			g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_settings_get_type (), GtkSettings), "gtk-application-prefer-dark-theme", &_tmp13_, NULL);
			_tmp14_ = _tmp13_;
			if (_tmp14_ == TRUE) {
				_tmp11_ = TRUE;
			} else {
				GtkSettings* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				_tmp15_ = defaults;
				g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp16_, NULL);
				_tmp17_ = _tmp16_;
				_tmp18_ = _tmp17_;
				_tmp11_ = g_strcmp0 (_tmp18_, "Adwaita-dark") == 0;
				_g_free0 (_tmp18_);
			}
			_tmp9_ = _tmp11_;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			gchar* _tmp19_;
			_tmp19_ = g_strdup ("adwaita.theme");
			_g_free0 (filename);
			filename = _tmp19_;
		} else {
			gchar* _tmp20_;
			_tmp20_ = g_strdup ("classic.theme");
			_g_free0 (filename);
			filename = _tmp20_;
		}
	}
	_tmp21_ = filename;
	_tmp22_ = g_build_filename (DATA_DIRECTORY, "themes", "key", _tmp21_, NULL);
	filepath = _tmp22_;
	{
		g_key_file_load_from_file (*key, filepath, G_KEY_FILE_NONE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		_inner_error0_ = NULL;
		g_assert_not_reached ();
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (filepath);
		_g_free0 (filename);
		_g_object_unref0 (defaults);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (filepath);
	_g_free0 (filename);
	_g_object_unref0 (defaults);
}

static void
game_view_load_theme (GameView* self,
                      GKeyFile* key)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	{
		gchar* svg_path = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gboolean _tmp9_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gint _tmp15_ = 0;
		gdouble _tmp16_ = 0.0;
		gdouble _tmp17_ = 0.0;
		gdouble _tmp18_ = 0.0;
		gint _tmp19_ = 0;
		gdouble _tmp20_ = 0.0;
		gdouble _tmp21_ = 0.0;
		gdouble _tmp22_ = 0.0;
		gint _tmp23_ = 0;
		gdouble _tmp24_ = 0.0;
		gdouble _tmp25_ = 0.0;
		gdouble _tmp26_ = 0.0;
		gint _tmp27_ = 0;
		gdouble _tmp28_ = 0.0;
		gdouble _tmp29_ = 0.0;
		gdouble _tmp30_ = 0.0;
		gdouble _tmp31_ = 0.0;
		gchar* _tmp32_ = NULL;
		gchar* _tmp33_;
		gchar* _tmp34_ = NULL;
		gchar* _tmp35_;
		_tmp0_ = g_build_filename (DATA_DIRECTORY, "themes", "svg", NULL);
		svg_path = _tmp0_;
		_tmp2_ = g_key_file_get_string (key, "Pieces", "File", &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = svg_path;
		_tmp4_ = g_build_filename (_tmp3_, _tmp1_, NULL);
		_g_free0 (self->priv->pieces_file);
		self->priv->pieces_file = _tmp4_;
		_tmp5_ = self->priv->pieces_file;
		_tmp6_ = g_path_get_dirname (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = svg_path;
		_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
		_g_free0 (_tmp7_);
		if (_tmp9_) {
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp10_ = svg_path;
			_tmp11_ = g_build_filename (_tmp10_, "black_and_white.svg", NULL);
			_g_free0 (self->priv->pieces_file);
			self->priv->pieces_file = _tmp11_;
		}
		_tmp12_ = g_key_file_get_double (key, "Background", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->background_red = _tmp12_;
		_tmp13_ = g_key_file_get_double (key, "Background", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->background_green = _tmp13_;
		_tmp14_ = g_key_file_get_double (key, "Background", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->background_blue = _tmp14_;
		_tmp15_ = g_key_file_get_integer (key, "Background", "Radius", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->background_radius = _tmp15_;
		_tmp16_ = g_key_file_get_double (key, "Mark", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->mark_red = _tmp16_;
		_tmp17_ = g_key_file_get_double (key, "Mark", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->mark_green = _tmp17_;
		_tmp18_ = g_key_file_get_double (key, "Mark", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->mark_blue = _tmp18_;
		_tmp19_ = g_key_file_get_integer (key, "Mark", "Width", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->mark_width = _tmp19_;
		_tmp20_ = g_key_file_get_double (key, "Border", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->border_red = _tmp20_;
		_tmp21_ = g_key_file_get_double (key, "Border", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->border_green = _tmp21_;
		_tmp22_ = g_key_file_get_double (key, "Border", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->border_blue = _tmp22_;
		_tmp23_ = g_key_file_get_integer (key, "Border", "Width", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->border_width = _tmp23_;
		_tmp24_ = g_key_file_get_double (key, "Spacing", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->spacing_red = _tmp24_;
		_tmp25_ = g_key_file_get_double (key, "Spacing", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->spacing_green = _tmp25_;
		_tmp26_ = g_key_file_get_double (key, "Spacing", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->spacing_blue = _tmp26_;
		_tmp27_ = g_key_file_get_integer (key, "Spacing", "Width", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->spacing_width = _tmp27_;
		_tmp28_ = g_key_file_get_double (key, "Highlight", "Red", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_red = _tmp28_;
		_tmp29_ = g_key_file_get_double (key, "Highlight", "Green", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_green = _tmp29_;
		_tmp30_ = g_key_file_get_double (key, "Highlight", "Blue", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_blue = _tmp30_;
		_tmp31_ = g_key_file_get_double (key, "Highlight", "Alpha", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		self->priv->highlight_alpha = _tmp31_;
		_tmp33_ = g_key_file_get_string (key, "Sound", "Flip", &_inner_error0_);
		_tmp32_ = _tmp33_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		game_view_set_sound_flip (self, _tmp32_);
		_tmp35_ = g_key_file_get_string (key, "Sound", "GameOver", &_inner_error0_);
		_tmp34_ = _tmp35_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp32_);
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
				goto __catch1_g_key_file_error;
			}
			_g_free0 (_tmp32_);
			_g_free0 (_tmp1_);
			_g_free0 (svg_path);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		game_view_set_sound_gameover (self, _tmp34_);
		_g_free0 (_tmp34_);
		_g_free0 (_tmp32_);
		_g_free0 (_tmp1_);
		_g_free0 (svg_path);
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp36_ = e;
		_tmp37_ = _tmp36_->message;
		g_warning ("game-view.vala:246: Errors when loading theme: %s", _tmp37_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
game_view_calculate (GameView* self)
{
	gint size = 0;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
	size = MIN (gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self));
	self->priv->paving_size = ((size - (2 * self->priv->border_width)) + self->priv->spacing_width) / self->priv->game_size;
	self->priv->tile_size = self->priv->paving_size - self->priv->spacing_width;
	self->priv->board_size = (self->priv->paving_size * self->priv->game_size) - self->priv->spacing_width;
}

static gboolean
game_view_real_draw (GtkWidget* base,
                     cairo_t* cr)
{
	GameView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	cairo_pattern_t* _tmp1_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	self = (GameView*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	if (!self->priv->game_is_set) {
		result = FALSE;
		return result;
	}
	game_view_calculate (self);
	_tmp1_ = self->priv->tiles_pattern;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->render_size != ((guint) self->priv->tile_size);
	}
	if (_tmp0_) {
		cairo_surface_t* surface = NULL;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
		cairo_t* c = NULL;
		cairo_surface_t* _tmp4_;
		cairo_t* _tmp5_;
		cairo_t* _tmp6_;
		cairo_surface_t* _tmp7_;
		cairo_pattern_t* _tmp8_;
		self->priv->render_size = (guint) self->priv->tile_size;
		_tmp2_ = cairo_get_target (cr);
		_tmp3_ = cairo_surface_create_similar (_tmp2_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size * 8, self->priv->tile_size * 4);
		surface = _tmp3_;
		_tmp4_ = surface;
		_tmp5_ = cairo_create (_tmp4_);
		c = _tmp5_;
		_tmp6_ = c;
		game_view_load_image (self, _tmp6_, self->priv->tile_size * 8, self->priv->tile_size * 4);
		_tmp7_ = surface;
		_tmp8_ = cairo_pattern_create_for_surface (_tmp7_);
		_cairo_pattern_destroy0 (self->priv->tiles_pattern);
		self->priv->tiles_pattern = _tmp8_;
		_cairo_destroy0 (c);
		_cairo_surface_destroy0 (surface);
	}
	_tmp9_ = game_view_get_board_x (self);
	_tmp10_ = _tmp9_;
	_tmp11_ = game_view_get_board_y (self);
	_tmp12_ = _tmp11_;
	cairo_translate (cr, (gdouble) _tmp10_, (gdouble) _tmp12_);
	cairo_set_source_rgba (cr, self->priv->spacing_red, self->priv->spacing_green, self->priv->spacing_blue, 1.0);
	cairo_rectangle (cr, (-self->priv->border_width) / 2.0, (-self->priv->border_width) / 2.0, (gdouble) (self->priv->board_size + self->priv->border_width), (gdouble) (self->priv->board_size + self->priv->border_width));
	cairo_fill_preserve (cr);
	cairo_set_source_rgba (cr, self->priv->border_red, self->priv->border_green, self->priv->border_blue, 1.0);
	cairo_set_line_width (cr, (gdouble) self->priv->border_width);
	cairo_stroke (cr);
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp13_ = FALSE;
			_tmp13_ = TRUE;
			while (TRUE) {
				if (!_tmp13_) {
					guint8 _tmp14_;
					_tmp14_ = x;
					x = _tmp14_ + 1;
				}
				_tmp13_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp15_ = FALSE;
						_tmp15_ = TRUE;
						while (TRUE) {
							gint tile_x = 0;
							gint tile_y = 0;
							gboolean _tmp17_ = FALSE;
							gboolean _tmp18_ = FALSE;
							gboolean _tmp19_ = FALSE;
							gint* _tmp32_;
							gint _tmp32__length1;
							gint _tmp32__length2;
							gint _tmp33_;
							gint texture_x = 0;
							gint* _tmp34_;
							gint _tmp34__length1;
							gint _tmp34__length2;
							gint _tmp35_;
							gint texture_y = 0;
							gint* _tmp36_;
							gint _tmp36__length1;
							gint _tmp36__length2;
							gint _tmp37_;
							cairo_matrix_t matrix = {0};
							cairo_pattern_t* _tmp38_;
							cairo_matrix_t _tmp39_;
							cairo_pattern_t* _tmp40_;
							if (!_tmp15_) {
								guint8 _tmp16_;
								_tmp16_ = y;
								y = _tmp16_ + 1;
							}
							_tmp15_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							tile_x = ((gint) x) * self->priv->paving_size;
							tile_y = ((gint) y) * self->priv->paving_size;
							cairo_set_source_rgba (cr, self->priv->background_red, self->priv->background_green, self->priv->background_blue, 1.0);
							game_view_rounded_square (self, cr, (gdouble) tile_x, (gdouble) tile_y, self->priv->tile_size, (gdouble) 0, (gdouble) self->priv->background_radius);
							cairo_fill (cr);
							if (self->priv->highlight_x == x) {
								_tmp19_ = self->priv->highlight_y == y;
							} else {
								_tmp19_ = FALSE;
							}
							if (_tmp19_) {
								gboolean _tmp20_ = FALSE;
								if (self->priv->show_highlight) {
									_tmp20_ = TRUE;
								} else {
									_tmp20_ = ((gint) self->priv->highlight_state) != 0;
								}
								_tmp18_ = _tmp20_;
							} else {
								_tmp18_ = FALSE;
							}
							if (_tmp18_) {
								Game* _tmp21_;
								Game* _tmp22_;
								gboolean _tmp23_;
								gboolean _tmp24_;
								_tmp21_ = game_view_get_game (self);
								_tmp22_ = _tmp21_;
								_tmp23_ = game_get_is_complete (_tmp22_);
								_tmp24_ = _tmp23_;
								_tmp17_ = !_tmp24_;
							} else {
								_tmp17_ = FALSE;
							}
							if (_tmp17_) {
								gboolean _tmp25_ = FALSE;
								if (self->priv->show_highlight) {
									_tmp25_ = self->priv->highlight_state != GAME_VIEW_HIGHLIGHT_MAX;
								} else {
									_tmp25_ = FALSE;
								}
								if (_tmp25_) {
									guint8 _tmp26_;
									gint _tmp27_;
									gint _tmp28_;
									gint _tmp29_;
									gint _tmp30_;
									_tmp26_ = self->priv->highlight_state;
									self->priv->highlight_state = _tmp26_ + 1;
									_tmp27_ = game_view_get_board_x (self);
									_tmp28_ = _tmp27_;
									_tmp29_ = game_view_get_board_y (self);
									_tmp30_ = _tmp29_;
									gtk_widget_queue_draw_area ((GtkWidget*) self, _tmp28_ + tile_x, _tmp30_ + tile_y, self->priv->tile_size, self->priv->tile_size);
								} else {
									gboolean _tmp31_ = FALSE;
									if (!self->priv->show_highlight) {
										_tmp31_ = ((gint) self->priv->highlight_state) != 0;
									} else {
										_tmp31_ = FALSE;
									}
									if (_tmp31_) {
										self->priv->highlight_state = (guint8) 0;
									}
								}
								cairo_set_source_rgba (cr, self->priv->highlight_red, self->priv->highlight_green, self->priv->highlight_blue, self->priv->highlight_alpha);
								game_view_rounded_square (self, cr, (gdouble) (tile_x + ((self->priv->tile_size * (GAME_VIEW_HIGHLIGHT_MAX - self->priv->highlight_state)) / (2 * GAME_VIEW_HIGHLIGHT_MAX))), (gdouble) (tile_y + ((self->priv->tile_size * (GAME_VIEW_HIGHLIGHT_MAX - self->priv->highlight_state)) / (2 * GAME_VIEW_HIGHLIGHT_MAX))), (self->priv->tile_size * self->priv->highlight_state) / GAME_VIEW_HIGHLIGHT_MAX, (gdouble) 0, (gdouble) self->priv->background_radius);
								cairo_fill (cr);
							}
							_tmp32_ = self->priv->pixmaps;
							_tmp32__length1 = self->priv->pixmaps_length1;
							_tmp32__length2 = self->priv->pixmaps_length2;
							_tmp33_ = _tmp32_[(x * _tmp32__length2) + y];
							if (_tmp33_ == 0) {
								continue;
							}
							_tmp34_ = self->priv->pixmaps;
							_tmp34__length1 = self->priv->pixmaps_length1;
							_tmp34__length2 = self->priv->pixmaps_length2;
							_tmp35_ = _tmp34_[(x * _tmp34__length2) + y];
							texture_x = (_tmp35_ % 8) * self->priv->tile_size;
							_tmp36_ = self->priv->pixmaps;
							_tmp36__length1 = self->priv->pixmaps_length1;
							_tmp36__length2 = self->priv->pixmaps_length2;
							_tmp37_ = _tmp36_[(x * _tmp36__length2) + y];
							texture_y = (_tmp37_ / 8) * self->priv->tile_size;
							cairo_matrix_init_identity (&matrix);
							cairo_matrix_translate (&matrix, (gdouble) (texture_x - tile_x), (gdouble) (texture_y - tile_y));
							_tmp38_ = self->priv->tiles_pattern;
							_tmp39_ = matrix;
							cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp38_, &_tmp39_);
							_tmp40_ = self->priv->tiles_pattern;
							cairo_set_source (cr, (cairo_pattern_t*) _tmp40_);
							cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) self->priv->tile_size, (gdouble) self->priv->tile_size);
							cairo_fill (cr);
						}
					}
				}
			}
		}
	}
	result = FALSE;
	return result;
}

static void
game_view_rounded_square (GameView* self,
                          cairo_t* cr,
                          gdouble x,
                          gdouble y,
                          gint size,
                          gdouble width,
                          gdouble radius_percent)
{
	gdouble radius_border = 0.0;
	gdouble radius_arc = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	if (radius_percent <= ((gdouble) 0)) {
		cairo_rectangle (cr, x + (width / 2.0), y + (width / 2.0), size + width, size + width);
		return;
	}
	if (radius_percent > ((gdouble) 50)) {
		radius_percent = (gdouble) 50;
	}
	radius_border = (radius_percent * size) / 100.0;
	radius_arc = radius_border - (width / 2.0);
	x1 = x + radius_border;
	y1 = y + radius_border;
	x2 = (x + size) - radius_border;
	y2 = (y + size) - radius_border;
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -GAME_VIEW_HALF_PI);
	cairo_arc (cr, x2, y1, radius_arc, -GAME_VIEW_HALF_PI, (gdouble) 0);
	cairo_arc (cr, x2, y2, radius_arc, (gdouble) 0, GAME_VIEW_HALF_PI);
	cairo_arc (cr, x1, y2, radius_arc, GAME_VIEW_HALF_PI, G_PI);
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -GAME_VIEW_HALF_PI);
}

static void
game_view_load_image (GameView* self,
                      cairo_t* c,
                      gint width,
                      gint height)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	{
		RsvgHandle* h = NULL;
		const gchar* _tmp0_;
		RsvgHandle* _tmp1_;
		cairo_matrix_t m = {0};
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		cairo_matrix_t _tmp6_;
		_tmp0_ = self->priv->pieces_file;
		_tmp1_ = rsvg_handle_new_from_file (_tmp0_, &_inner_error0_);
		h = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch2_g_error;
		}
		cairo_matrix_init_identity (&m);
		g_object_get (h, "width", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		g_object_get (h, "height", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		cairo_matrix_scale (&m, ((gdouble) width) / _tmp3_, ((gdouble) height) / _tmp5_);
		_tmp6_ = m;
		cairo_set_matrix (c, &_tmp6_);
		rsvg_handle_render_cairo (h, c);
		_g_object_unref0 (h);
		return;
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	{
		GdkPixbuf* p = NULL;
		const gchar* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		_tmp7_ = self->priv->pieces_file;
		_tmp8_ = gdk_pixbuf_new_from_file_at_scale (_tmp7_, width, height, FALSE, &_inner_error0_);
		p = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch3_g_error;
		}
		_tmp9_ = p;
		gdk_cairo_set_source_pixbuf (c, _tmp9_, (gdouble) 0, (gdouble) 0);
		cairo_paint (c);
		_g_object_unref0 (p);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp10_ = self->priv->pieces_file;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_warning ("game-view.vala:401: Failed to load theme image %s: %s", _tmp10_, _tmp12_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
game_view_square_changed_cb (GameView* self,
                             guint8 x,
                             guint8 y,
                             Player replacement)
{
	g_return_if_fail (self != NULL);
	if (replacement == PLAYER_NONE) {
		if (self->priv->show_highlight) {
			Game* _tmp0_;
			Game* _tmp1_;
			Game* _tmp2_;
			Game* _tmp3_;
			gboolean _tmp4_;
			gboolean _tmp5_;
			self->priv->highlight_state = (guint8) 0;
			_tmp0_ = game_view_get_game (self);
			_tmp1_ = _tmp0_;
			game_view_set_square (self, self->priv->highlight_x, self->priv->highlight_y, game_view_get_pixmap (game_get_owner (_tmp1_, x, y)), FALSE, TRUE);
			_tmp2_ = game_view_get_game (self);
			_tmp3_ = _tmp2_;
			_tmp4_ = game_get_is_complete (_tmp3_);
			_tmp5_ = _tmp4_;
			if (!_tmp5_) {
				self->priv->highlight_state = GAME_VIEW_HIGHLIGHT_MAX;
			}
		}
		self->priv->highlight_set = TRUE;
		self->priv->highlight_x = x;
		self->priv->highlight_y = y;
	}
	game_view_update_square (self, x, y);
}

static inline void
game_view_update_square (GameView* self,
                         guint8 x,
                         guint8 y)
{
	Game* _tmp0_;
	Game* _tmp1_;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
	_tmp0_ = game_view_get_game (self);
	_tmp1_ = _tmp0_;
	game_view_set_square (self, x, y, game_view_get_pixmap (game_get_owner (_tmp1_, x, y)), FALSE, FALSE);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		GameView* self;
		self = _data2_->self;
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gboolean
____lambda7_ (Block2Data* _data2_)
{
	GameView* self;
	gboolean result = FALSE;
	gboolean animating = FALSE;
	self = _data2_->self;
	animating = FALSE;
	{
		guint8 ix = 0U;
		ix = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = ix;
					ix = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(ix < self->priv->game_size)) {
					break;
				}
				{
					guint8 iy = 0U;
					iy = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							gint old = 0;
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gint* _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							gint _tmp13_;
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = iy;
								iy = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(iy < self->priv->game_size)) {
								break;
							}
							_tmp4_ = self->priv->pixmaps;
							_tmp4__length1 = self->priv->pixmaps_length1;
							_tmp4__length2 = self->priv->pixmaps_length2;
							_tmp5_ = _tmp4_[(ix * _tmp4__length2) + iy];
							old = _tmp5_;
							if (_data2_->is_final_animation) {
								_tmp7_ = self->priv->flip_final_result_now;
							} else {
								_tmp7_ = FALSE;
							}
							if (_tmp7_) {
								Game* _tmp8_;
								Game* _tmp9_;
								gboolean _tmp10_;
								gboolean _tmp11_;
								_tmp8_ = game_view_get_game (self);
								_tmp9_ = _tmp8_;
								_tmp10_ = game_get_is_complete (_tmp9_);
								_tmp11_ = _tmp10_;
								_tmp6_ = _tmp11_;
							} else {
								_tmp6_ = FALSE;
							}
							if (_tmp6_) {
								game_view_flip_final_result_tile (self, ix, iy);
							} else {
								game_view_update_square (self, ix, iy);
							}
							_tmp12_ = self->priv->pixmaps;
							_tmp12__length1 = self->priv->pixmaps_length1;
							_tmp12__length2 = self->priv->pixmaps_length2;
							_tmp13_ = _tmp12_[(ix * _tmp12__length2) + iy];
							if (_tmp13_ != old) {
								animating = TRUE;
							}
						}
					}
				}
			}
		}
	}
	if (animating) {
		result = G_SOURCE_CONTINUE;
		return result;
	} else {
		self->priv->animate_timeout = (guint) 0;
		result = G_SOURCE_REMOVE;
		return result;
	}
}

static gboolean
_____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda7_ (self);
	return result;
}

static void
game_view_set_square (GameView* self,
                      guint8 x,
                      guint8 y,
                      gint pixmap,
                      gboolean is_final_animation,
                      gboolean force_redraw)
{
	Block2Data* _data2_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	g_return_if_fail (self != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_data2_->is_final_animation = is_final_animation;
	if (!force_redraw) {
		gint* _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		gint _tmp2_;
		_tmp1_ = self->priv->pixmaps;
		_tmp1__length1 = self->priv->pixmaps_length1;
		_tmp1__length2 = self->priv->pixmaps_length2;
		_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
		_tmp0_ = _tmp2_ == pixmap;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	if (pixmap == 0) {
		_tmp3_ = TRUE;
	} else {
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
		_tmp4_ = self->priv->pixmaps;
		_tmp4__length1 = self->priv->pixmaps_length1;
		_tmp4__length2 = self->priv->pixmaps_length2;
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
		_tmp3_ = _tmp5_ == 0;
	}
	if (_tmp3_) {
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		_tmp6_ = self->priv->pixmaps;
		_tmp6__length1 = self->priv->pixmaps_length1;
		_tmp6__length2 = self->priv->pixmaps_length2;
		_tmp6_[(x * _tmp6__length2) + y] = pixmap;
	} else {
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp8_;
		_tmp7_ = self->priv->pixmaps;
		_tmp7__length1 = self->priv->pixmaps_length1;
		_tmp7__length2 = self->priv->pixmaps_length2;
		_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
		if (pixmap > _tmp8_) {
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			gint _tmp10_;
			_tmp9_ = self->priv->pixmaps;
			_tmp9__length1 = self->priv->pixmaps_length1;
			_tmp9__length2 = self->priv->pixmaps_length2;
			_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
			_tmp9_[(x * _tmp9__length2) + y] = _tmp10_ + 1;
		} else {
			gint* _tmp11_;
			gint _tmp11__length1;
			gint _tmp11__length2;
			gint _tmp12_;
			_tmp11_ = self->priv->pixmaps;
			_tmp11__length1 = self->priv->pixmaps_length1;
			_tmp11__length2 = self->priv->pixmaps_length2;
			_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
			_tmp11_[(x * _tmp11__length2) + y] = _tmp12_ - 1;
		}
		if (self->priv->animate_timeout == ((guint) 0)) {
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GAME_VIEW_PIXMAP_FLIP_DELAY, _____lambda7__gsource_func, block2_data_ref (_data2_), block2_data_unref);
		}
	}
	_tmp13_ = game_view_get_board_x (self);
	_tmp14_ = _tmp13_;
	_tmp15_ = game_view_get_board_y (self);
	_tmp16_ = _tmp15_;
	gtk_widget_queue_draw_area ((GtkWidget*) self, (gint) (_tmp14_ + (x * self->priv->paving_size)), (gint) (_tmp16_ + (y * self->priv->paving_size)), self->priv->tile_size, self->priv->tile_size);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static gint
game_view_get_pixmap (Player color)
{
	gint result = 0;
	switch (color) {
		default:
		case PLAYER_NONE:
		{
			result = 0;
			return result;
		}
		case PLAYER_DARK:
		{
			result = 1;
			return result;
		}
		case PLAYER_LIGHT:
		{
			result = 31;
			return result;
		}
	}
}

static gboolean
__lambda6_ (GameView* self)
{
	gboolean result = FALSE;
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = game_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_is_complete (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		result = G_SOURCE_REMOVE;
		return result;
	}
	game_view_set_winner_and_loser_variables (self);
	self->priv->flip_final_result_now = TRUE;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				if (!_tmp4_) {
					guint8 _tmp5_;
					_tmp5_ = x;
					x = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							if (!_tmp6_) {
								guint8 _tmp7_;
								_tmp7_ = y;
								y = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							game_view_flip_final_result_tile (self, x, y);
						}
					}
				}
			}
		}
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ ((GameView*) self);
	return result;
}

static void
game_view_game_is_complete_cb (GameView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	Game* _tmp5_;
	Game* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = game_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_is_complete (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		return;
	}
	_tmp5_ = game_view_get_game (self);
	_tmp6_ = _tmp5_;
	_tmp7_ = game_get_n_light_tiles (_tmp6_);
	_tmp8_ = _tmp7_;
	if (((gint) _tmp8_) == 0) {
		_tmp4_ = TRUE;
	} else {
		Game* _tmp9_;
		Game* _tmp10_;
		guint8 _tmp11_;
		guint8 _tmp12_;
		_tmp9_ = game_view_get_game (self);
		_tmp10_ = _tmp9_;
		_tmp11_ = game_get_n_dark_tiles (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp4_ = ((gint) _tmp12_) == 0;
	}
	if (_tmp4_) {
		return;
	}
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
}

static void
game_view_flip_final_result_tile (GameView* self,
                                  guint8 x,
                                  guint8 y)
{
	gint pixmap = 0;
	guint8 n = 0U;
	g_return_if_fail (self != NULL);
	n = (y * self->priv->game_size) + x;
	if (((gint) n) < self->priv->n_winning_tiles) {
		Player _tmp0_;
		_tmp0_ = self->priv->winning_color;
		pixmap = game_view_get_pixmap (_tmp0_);
	} else {
		if (((gint) n) < (self->priv->n_winning_tiles + self->priv->n_losing_tiles)) {
			Player _tmp1_;
			_tmp1_ = self->priv->losing_color;
			pixmap = game_view_get_pixmap (_tmp1_);
		} else {
			pixmap = game_view_get_pixmap (PLAYER_NONE);
		}
	}
	game_view_set_square (self, x, y, pixmap, TRUE, FALSE);
}

static void
game_view_set_winner_and_loser_variables (GameView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = game_view_get_game (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_n_light_tiles (_tmp1_);
	_tmp3_ = _tmp2_;
	self->priv->n_winning_tiles = (gint) _tmp3_;
	_tmp4_ = game_view_get_game (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = game_get_n_dark_tiles (_tmp5_);
	_tmp7_ = _tmp6_;
	self->priv->n_losing_tiles = (gint) _tmp7_;
	if (self->priv->n_losing_tiles > self->priv->n_winning_tiles) {
		gint t = 0;
		self->priv->winning_color = PLAYER_DARK;
		self->priv->losing_color = PLAYER_LIGHT;
		t = self->priv->n_winning_tiles;
		self->priv->n_winning_tiles = self->priv->n_losing_tiles;
		self->priv->n_losing_tiles = t;
	} else {
		self->priv->winning_color = PLAYER_LIGHT;
		self->priv->losing_color = PLAYER_DARK;
	}
}

gboolean
game_view_undo_final_animation (GameView* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!self->priv->flip_final_result_now) {
		result = FALSE;
		return result;
	}
	self->priv->flip_final_result_now = FALSE;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							game_view_update_square (self, x, y);
						}
					}
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static gboolean
game_view_real_button_press_event (GtkWidget* base,
                                   GdkEventButton* event)
{
	GameView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = (GameView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (!self->priv->game_is_set) {
		result = FALSE;
		return result;
	}
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = event->button == ((guint) GDK_BUTTON_SECONDARY);
	}
	if (_tmp0_) {
		gint8 x = 0;
		gint _tmp1_;
		gint _tmp2_;
		gint8 y = 0;
		gint _tmp3_;
		gint _tmp4_;
		Game* _tmp5_;
		Game* _tmp6_;
		_tmp1_ = game_view_get_board_x (self);
		_tmp2_ = _tmp1_;
		x = (gint8) ((event->x - _tmp2_) / self->priv->paving_size);
		_tmp3_ = game_view_get_board_y (self);
		_tmp4_ = _tmp3_;
		y = (gint8) ((event->y - _tmp4_) / self->priv->paving_size);
		_tmp5_ = game_view_get_game (self);
		_tmp6_ = _tmp5_;
		if (game_is_valid_location_signed (_tmp6_, x, y)) {
			self->priv->show_highlight = FALSE;
			gtk_widget_queue_draw ((GtkWidget*) self);
			self->priv->highlight_set = TRUE;
			self->priv->highlight_x = (guint8) x;
			self->priv->highlight_y = (guint8) y;
			g_signal_emit (self, game_view_signals[GAME_VIEW_MOVE_SIGNAL], 0, self->priv->highlight_x, self->priv->highlight_y);
		}
	}
	result = TRUE;
	return result;
}

static gboolean
game_view_real_key_press_event (GtkWidget* base,
                                GdkEventKey* event)
{
	GameView * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* key = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	guint8 old_highlight_x = 0U;
	guint8 old_highlight_y = 0U;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	GQuark _tmp65_ = 0U;
	static GQuark _tmp64_label0 = 0;
	static GQuark _tmp64_label1 = 0;
	static GQuark _tmp64_label2 = 0;
	static GQuark _tmp64_label3 = 0;
	static GQuark _tmp64_label4 = 0;
	static GQuark _tmp64_label5 = 0;
	static GQuark _tmp64_label6 = 0;
	static GQuark _tmp64_label7 = 0;
	static GQuark _tmp64_label8 = 0;
	static GQuark _tmp64_label9 = 0;
	static GQuark _tmp64_label10 = 0;
	static GQuark _tmp64_label11 = 0;
	static GQuark _tmp64_label12 = 0;
	static GQuark _tmp64_label13 = 0;
	static GQuark _tmp64_label14 = 0;
	static GQuark _tmp64_label15 = 0;
	static GQuark _tmp64_label16 = 0;
	static GQuark _tmp64_label17 = 0;
	static GQuark _tmp64_label18 = 0;
	static GQuark _tmp64_label19 = 0;
	static GQuark _tmp64_label20 = 0;
	static GQuark _tmp64_label21 = 0;
	static GQuark _tmp64_label22 = 0;
	static GQuark _tmp64_label23 = 0;
	static GQuark _tmp64_label24 = 0;
	static GQuark _tmp64_label25 = 0;
	static GQuark _tmp64_label26 = 0;
	static GQuark _tmp64_label27 = 0;
	static GQuark _tmp64_label28 = 0;
	static GQuark _tmp64_label29 = 0;
	static GQuark _tmp64_label30 = 0;
	static GQuark _tmp64_label31 = 0;
	static GQuark _tmp64_label32 = 0;
	static GQuark _tmp64_label33 = 0;
	static GQuark _tmp64_label34 = 0;
	static GQuark _tmp64_label35 = 0;
	static GQuark _tmp64_label36 = 0;
	static GQuark _tmp64_label37 = 0;
	static GQuark _tmp64_label38 = 0;
	static GQuark _tmp64_label39 = 0;
	static GQuark _tmp64_label40 = 0;
	static GQuark _tmp64_label41 = 0;
	static GQuark _tmp64_label42 = 0;
	static GQuark _tmp64_label43 = 0;
	static GQuark _tmp64_label44 = 0;
	static GQuark _tmp64_label45 = 0;
	static GQuark _tmp64_label46 = 0;
	static GQuark _tmp64_label47 = 0;
	static GQuark _tmp64_label48 = 0;
	static GQuark _tmp64_label49 = 0;
	static GQuark _tmp64_label50 = 0;
	static GQuark _tmp64_label51 = 0;
	static GQuark _tmp64_label52 = 0;
	static GQuark _tmp64_label53 = 0;
	static GQuark _tmp64_label54 = 0;
	static GQuark _tmp64_label55 = 0;
	static GQuark _tmp64_label56 = 0;
	static GQuark _tmp64_label57 = 0;
	static GQuark _tmp64_label58 = 0;
	static GQuark _tmp64_label59 = 0;
	const gchar* _tmp88_;
	gint _tmp89_;
	gint _tmp90_;
	gint _tmp91_;
	gint _tmp92_;
	gboolean _tmp93_ = FALSE;
	self = (GameView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (!self->priv->game_is_set) {
		result = FALSE;
		return result;
	}
	_tmp1_ = gdk_keyval_name (event->keyval);
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "";
	}
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
	key = _tmp2_;
	if (self->priv->show_highlight) {
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		_tmp6_ = key;
		if (g_strcmp0 (_tmp6_, "space") == 0) {
			_tmp5_ = TRUE;
		} else {
			const gchar* _tmp7_;
			_tmp7_ = key;
			_tmp5_ = g_strcmp0 (_tmp7_, "Return") == 0;
		}
		if (_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			const gchar* _tmp8_;
			_tmp8_ = key;
			_tmp4_ = g_strcmp0 (_tmp8_, "KP_Enter") == 0;
		}
		_tmp3_ = _tmp4_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		g_signal_emit (self, game_view_signals[GAME_VIEW_MOVE_SIGNAL], 0, self->priv->highlight_x, self->priv->highlight_y);
		result = TRUE;
		_g_free0 (key);
		return result;
	}
	if (((gint) self->priv->game_size) <= 4) {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		const gchar* _tmp18_;
		_tmp18_ = key;
		if (g_strcmp0 (_tmp18_, "e") == 0) {
			_tmp17_ = TRUE;
		} else {
			const gchar* _tmp19_;
			_tmp19_ = key;
			_tmp17_ = g_strcmp0 (_tmp19_, "E") == 0;
		}
		if (_tmp17_) {
			_tmp16_ = TRUE;
		} else {
			const gchar* _tmp20_;
			_tmp20_ = key;
			_tmp16_ = g_strcmp0 (_tmp20_, "5") == 0;
		}
		if (_tmp16_) {
			_tmp15_ = TRUE;
		} else {
			const gchar* _tmp21_;
			_tmp21_ = key;
			_tmp15_ = g_strcmp0 (_tmp21_, "KP_5") == 0;
		}
		_tmp14_ = _tmp15_;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		_tmp13_ = TRUE;
	} else {
		gboolean _tmp22_ = FALSE;
		if (((gint) self->priv->game_size) <= 5) {
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			const gchar* _tmp26_;
			_tmp26_ = key;
			if (g_strcmp0 (_tmp26_, "f") == 0) {
				_tmp25_ = TRUE;
			} else {
				const gchar* _tmp27_;
				_tmp27_ = key;
				_tmp25_ = g_strcmp0 (_tmp27_, "F") == 0;
			}
			if (_tmp25_) {
				_tmp24_ = TRUE;
			} else {
				const gchar* _tmp28_;
				_tmp28_ = key;
				_tmp24_ = g_strcmp0 (_tmp28_, "6") == 0;
			}
			if (_tmp24_) {
				_tmp23_ = TRUE;
			} else {
				const gchar* _tmp29_;
				_tmp29_ = key;
				_tmp23_ = g_strcmp0 (_tmp29_, "KP_6") == 0;
			}
			_tmp22_ = _tmp23_;
		} else {
			_tmp22_ = FALSE;
		}
		_tmp13_ = _tmp22_;
	}
	if (_tmp13_) {
		_tmp12_ = TRUE;
	} else {
		gboolean _tmp30_ = FALSE;
		if (((gint) self->priv->game_size) <= 6) {
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			gboolean _tmp33_ = FALSE;
			const gchar* _tmp34_;
			_tmp34_ = key;
			if (g_strcmp0 (_tmp34_, "g") == 0) {
				_tmp33_ = TRUE;
			} else {
				const gchar* _tmp35_;
				_tmp35_ = key;
				_tmp33_ = g_strcmp0 (_tmp35_, "G") == 0;
			}
			if (_tmp33_) {
				_tmp32_ = TRUE;
			} else {
				const gchar* _tmp36_;
				_tmp36_ = key;
				_tmp32_ = g_strcmp0 (_tmp36_, "7") == 0;
			}
			if (_tmp32_) {
				_tmp31_ = TRUE;
			} else {
				const gchar* _tmp37_;
				_tmp37_ = key;
				_tmp31_ = g_strcmp0 (_tmp37_, "KP_7") == 0;
			}
			_tmp30_ = _tmp31_;
		} else {
			_tmp30_ = FALSE;
		}
		_tmp12_ = _tmp30_;
	}
	if (_tmp12_) {
		_tmp11_ = TRUE;
	} else {
		gboolean _tmp38_ = FALSE;
		if (((gint) self->priv->game_size) <= 7) {
			gboolean _tmp39_ = FALSE;
			gboolean _tmp40_ = FALSE;
			gboolean _tmp41_ = FALSE;
			const gchar* _tmp42_;
			_tmp42_ = key;
			if (g_strcmp0 (_tmp42_, "h") == 0) {
				_tmp41_ = TRUE;
			} else {
				const gchar* _tmp43_;
				_tmp43_ = key;
				_tmp41_ = g_strcmp0 (_tmp43_, "H") == 0;
			}
			if (_tmp41_) {
				_tmp40_ = TRUE;
			} else {
				const gchar* _tmp44_;
				_tmp44_ = key;
				_tmp40_ = g_strcmp0 (_tmp44_, "8") == 0;
			}
			if (_tmp40_) {
				_tmp39_ = TRUE;
			} else {
				const gchar* _tmp45_;
				_tmp45_ = key;
				_tmp39_ = g_strcmp0 (_tmp45_, "KP_8") == 0;
			}
			_tmp38_ = _tmp39_;
		} else {
			_tmp38_ = FALSE;
		}
		_tmp11_ = _tmp38_;
	}
	if (_tmp11_) {
		_tmp10_ = TRUE;
	} else {
		gboolean _tmp46_ = FALSE;
		if (((gint) self->priv->game_size) <= 8) {
			gboolean _tmp47_ = FALSE;
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			const gchar* _tmp50_;
			_tmp50_ = key;
			if (g_strcmp0 (_tmp50_, "i") == 0) {
				_tmp49_ = TRUE;
			} else {
				const gchar* _tmp51_;
				_tmp51_ = key;
				_tmp49_ = g_strcmp0 (_tmp51_, "I") == 0;
			}
			if (_tmp49_) {
				_tmp48_ = TRUE;
			} else {
				const gchar* _tmp52_;
				_tmp52_ = key;
				_tmp48_ = g_strcmp0 (_tmp52_, "9") == 0;
			}
			if (_tmp48_) {
				_tmp47_ = TRUE;
			} else {
				const gchar* _tmp53_;
				_tmp53_ = key;
				_tmp47_ = g_strcmp0 (_tmp53_, "KP_9") == 0;
			}
			_tmp46_ = _tmp47_;
		} else {
			_tmp46_ = FALSE;
		}
		_tmp10_ = _tmp46_;
	}
	if (_tmp10_) {
		_tmp9_ = TRUE;
	} else {
		gboolean _tmp54_ = FALSE;
		if (((gint) self->priv->game_size) <= 9) {
			gboolean _tmp55_ = FALSE;
			gboolean _tmp56_ = FALSE;
			gboolean _tmp57_ = FALSE;
			const gchar* _tmp58_;
			_tmp58_ = key;
			if (g_strcmp0 (_tmp58_, "j") == 0) {
				_tmp57_ = TRUE;
			} else {
				const gchar* _tmp59_;
				_tmp59_ = key;
				_tmp57_ = g_strcmp0 (_tmp59_, "J") == 0;
			}
			if (_tmp57_) {
				_tmp56_ = TRUE;
			} else {
				const gchar* _tmp60_;
				_tmp60_ = key;
				_tmp56_ = g_strcmp0 (_tmp60_, "0") == 0;
			}
			if (_tmp56_) {
				_tmp55_ = TRUE;
			} else {
				const gchar* _tmp61_;
				_tmp61_ = key;
				_tmp55_ = g_strcmp0 (_tmp61_, "KP_0") == 0;
			}
			_tmp54_ = _tmp55_;
		} else {
			_tmp54_ = FALSE;
		}
		_tmp9_ = _tmp54_;
	}
	if (_tmp9_) {
		result = FALSE;
		_g_free0 (key);
		return result;
	}
	old_highlight_x = self->priv->highlight_x;
	old_highlight_y = self->priv->highlight_y;
	_tmp62_ = key;
	_tmp63_ = _tmp62_;
	_tmp65_ = (NULL == _tmp63_) ? 0 : g_quark_from_string (_tmp63_);
	if ((_tmp65_ == ((0 != _tmp64_label0) ? _tmp64_label0 : (_tmp64_label0 = g_quark_from_static_string ("Left")))) || (_tmp65_ == ((0 != _tmp64_label1) ? _tmp64_label1 : (_tmp64_label1 = g_quark_from_static_string ("KP_Left"))))) {
		switch (0) {
			default:
			{
				gboolean _tmp66_ = FALSE;
				if (!self->priv->highlight_set) {
					Game* _tmp67_;
					Game* _tmp68_;
					Player _tmp69_;
					Player _tmp70_;
					_tmp67_ = game_view_get_game (self);
					_tmp68_ = _tmp67_;
					_tmp69_ = game_get_current_color (_tmp68_);
					_tmp70_ = _tmp69_;
					_tmp66_ = _tmp70_ == PLAYER_LIGHT;
				} else {
					_tmp66_ = FALSE;
				}
				if (_tmp66_) {
					self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
				}
				if (((gint) self->priv->highlight_x) > 0) {
					guint8 _tmp71_;
					_tmp71_ = self->priv->highlight_x;
					self->priv->highlight_x = _tmp71_ - 1;
				}
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label2) ? _tmp64_label2 : (_tmp64_label2 = g_quark_from_static_string ("Right")))) || (_tmp65_ == ((0 != _tmp64_label3) ? _tmp64_label3 : (_tmp64_label3 = g_quark_from_static_string ("KP_Right"))))) {
		switch (0) {
			default:
			{
				if (!self->priv->highlight_set) {
					Game* _tmp72_;
					Game* _tmp73_;
					Player _tmp74_;
					Player _tmp75_;
					self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
					_tmp72_ = game_view_get_game (self);
					_tmp73_ = _tmp72_;
					_tmp74_ = game_get_current_color (_tmp73_);
					_tmp75_ = _tmp74_;
					if (_tmp75_ == PLAYER_DARK) {
						self->priv->highlight_y = self->priv->highlight_x;
					}
				}
				if (((gint) self->priv->highlight_x) < (self->priv->game_size - 1)) {
					guint8 _tmp76_;
					_tmp76_ = self->priv->highlight_x;
					self->priv->highlight_x = _tmp76_ + 1;
				}
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label4) ? _tmp64_label4 : (_tmp64_label4 = g_quark_from_static_string ("Up")))) || (_tmp65_ == ((0 != _tmp64_label5) ? _tmp64_label5 : (_tmp64_label5 = g_quark_from_static_string ("KP_Up"))))) {
		switch (0) {
			default:
			{
				gboolean _tmp77_ = FALSE;
				if (!self->priv->highlight_set) {
					Game* _tmp78_;
					Game* _tmp79_;
					Player _tmp80_;
					Player _tmp81_;
					_tmp78_ = game_view_get_game (self);
					_tmp79_ = _tmp78_;
					_tmp80_ = game_get_current_color (_tmp79_);
					_tmp81_ = _tmp80_;
					_tmp77_ = _tmp81_ == PLAYER_LIGHT;
				} else {
					_tmp77_ = FALSE;
				}
				if (_tmp77_) {
					self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
				}
				if (((gint) self->priv->highlight_y) > 0) {
					guint8 _tmp82_;
					_tmp82_ = self->priv->highlight_y;
					self->priv->highlight_y = _tmp82_ - 1;
				}
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label6) ? _tmp64_label6 : (_tmp64_label6 = g_quark_from_static_string ("Down")))) || (_tmp65_ == ((0 != _tmp64_label7) ? _tmp64_label7 : (_tmp64_label7 = g_quark_from_static_string ("KP_Down"))))) {
		switch (0) {
			default:
			{
				if (!self->priv->highlight_set) {
					Game* _tmp83_;
					Game* _tmp84_;
					Player _tmp85_;
					Player _tmp86_;
					self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
					_tmp83_ = game_view_get_game (self);
					_tmp84_ = _tmp83_;
					_tmp85_ = game_get_current_color (_tmp84_);
					_tmp86_ = _tmp85_;
					if (_tmp86_ == PLAYER_DARK) {
						self->priv->highlight_x = self->priv->highlight_y;
					}
				}
				if (((gint) self->priv->highlight_y) < (self->priv->game_size - 1)) {
					guint8 _tmp87_;
					_tmp87_ = self->priv->highlight_y;
					self->priv->highlight_y = _tmp87_ + 1;
				}
				break;
			}
		}
	} else if ((((_tmp65_ == ((0 != _tmp64_label8) ? _tmp64_label8 : (_tmp64_label8 = g_quark_from_static_string ("space")))) || (_tmp65_ == ((0 != _tmp64_label9) ? _tmp64_label9 : (_tmp64_label9 = g_quark_from_static_string ("Return"))))) || (_tmp65_ == ((0 != _tmp64_label10) ? _tmp64_label10 : (_tmp64_label10 = g_quark_from_static_string ("KP_Enter"))))) || (_tmp65_ == ((0 != _tmp64_label11) ? _tmp64_label11 : (_tmp64_label11 = g_quark_from_static_string ("Escape"))))) {
		switch (0) {
			default:
			{
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label12) ? _tmp64_label12 : (_tmp64_label12 = g_quark_from_static_string ("a")))) || (_tmp65_ == ((0 != _tmp64_label13) ? _tmp64_label13 : (_tmp64_label13 = g_quark_from_static_string ("A"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 0;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label14) ? _tmp64_label14 : (_tmp64_label14 = g_quark_from_static_string ("b")))) || (_tmp65_ == ((0 != _tmp64_label15) ? _tmp64_label15 : (_tmp64_label15 = g_quark_from_static_string ("B"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 1;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label16) ? _tmp64_label16 : (_tmp64_label16 = g_quark_from_static_string ("c")))) || (_tmp65_ == ((0 != _tmp64_label17) ? _tmp64_label17 : (_tmp64_label17 = g_quark_from_static_string ("C"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 2;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label18) ? _tmp64_label18 : (_tmp64_label18 = g_quark_from_static_string ("d")))) || (_tmp65_ == ((0 != _tmp64_label19) ? _tmp64_label19 : (_tmp64_label19 = g_quark_from_static_string ("D"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 3;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label20) ? _tmp64_label20 : (_tmp64_label20 = g_quark_from_static_string ("e")))) || (_tmp65_ == ((0 != _tmp64_label21) ? _tmp64_label21 : (_tmp64_label21 = g_quark_from_static_string ("E"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 4;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label22) ? _tmp64_label22 : (_tmp64_label22 = g_quark_from_static_string ("f")))) || (_tmp65_ == ((0 != _tmp64_label23) ? _tmp64_label23 : (_tmp64_label23 = g_quark_from_static_string ("F"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 5;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label24) ? _tmp64_label24 : (_tmp64_label24 = g_quark_from_static_string ("g")))) || (_tmp65_ == ((0 != _tmp64_label25) ? _tmp64_label25 : (_tmp64_label25 = g_quark_from_static_string ("G"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 6;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label26) ? _tmp64_label26 : (_tmp64_label26 = g_quark_from_static_string ("h")))) || (_tmp65_ == ((0 != _tmp64_label27) ? _tmp64_label27 : (_tmp64_label27 = g_quark_from_static_string ("H"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 7;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label28) ? _tmp64_label28 : (_tmp64_label28 = g_quark_from_static_string ("i")))) || (_tmp65_ == ((0 != _tmp64_label29) ? _tmp64_label29 : (_tmp64_label29 = g_quark_from_static_string ("I"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 8;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label30) ? _tmp64_label30 : (_tmp64_label30 = g_quark_from_static_string ("j")))) || (_tmp65_ == ((0 != _tmp64_label31) ? _tmp64_label31 : (_tmp64_label31 = g_quark_from_static_string ("J"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 9;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label32) ? _tmp64_label32 : (_tmp64_label32 = g_quark_from_static_string ("1")))) || (_tmp65_ == ((0 != _tmp64_label33) ? _tmp64_label33 : (_tmp64_label33 = g_quark_from_static_string ("KP_1"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 0;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label34) ? _tmp64_label34 : (_tmp64_label34 = g_quark_from_static_string ("2")))) || (_tmp65_ == ((0 != _tmp64_label35) ? _tmp64_label35 : (_tmp64_label35 = g_quark_from_static_string ("KP_2"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 1;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label36) ? _tmp64_label36 : (_tmp64_label36 = g_quark_from_static_string ("3")))) || (_tmp65_ == ((0 != _tmp64_label37) ? _tmp64_label37 : (_tmp64_label37 = g_quark_from_static_string ("KP_3"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 2;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label38) ? _tmp64_label38 : (_tmp64_label38 = g_quark_from_static_string ("4")))) || (_tmp65_ == ((0 != _tmp64_label39) ? _tmp64_label39 : (_tmp64_label39 = g_quark_from_static_string ("KP_4"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 3;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label40) ? _tmp64_label40 : (_tmp64_label40 = g_quark_from_static_string ("5")))) || (_tmp65_ == ((0 != _tmp64_label41) ? _tmp64_label41 : (_tmp64_label41 = g_quark_from_static_string ("KP_5"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 4;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label42) ? _tmp64_label42 : (_tmp64_label42 = g_quark_from_static_string ("6")))) || (_tmp65_ == ((0 != _tmp64_label43) ? _tmp64_label43 : (_tmp64_label43 = g_quark_from_static_string ("KP_6"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 5;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label44) ? _tmp64_label44 : (_tmp64_label44 = g_quark_from_static_string ("7")))) || (_tmp65_ == ((0 != _tmp64_label45) ? _tmp64_label45 : (_tmp64_label45 = g_quark_from_static_string ("KP_7"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 6;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label46) ? _tmp64_label46 : (_tmp64_label46 = g_quark_from_static_string ("8")))) || (_tmp65_ == ((0 != _tmp64_label47) ? _tmp64_label47 : (_tmp64_label47 = g_quark_from_static_string ("KP_8"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 7;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label48) ? _tmp64_label48 : (_tmp64_label48 = g_quark_from_static_string ("9")))) || (_tmp65_ == ((0 != _tmp64_label49) ? _tmp64_label49 : (_tmp64_label49 = g_quark_from_static_string ("KP_9"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 8;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label50) ? _tmp64_label50 : (_tmp64_label50 = g_quark_from_static_string ("0")))) || (_tmp65_ == ((0 != _tmp64_label51) ? _tmp64_label51 : (_tmp64_label51 = g_quark_from_static_string ("KP_0"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 9;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label52) ? _tmp64_label52 : (_tmp64_label52 = g_quark_from_static_string ("Home")))) || (_tmp65_ == ((0 != _tmp64_label53) ? _tmp64_label53 : (_tmp64_label53 = g_quark_from_static_string ("KP_Home"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) 0;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label54) ? _tmp64_label54 : (_tmp64_label54 = g_quark_from_static_string ("End")))) || (_tmp65_ == ((0 != _tmp64_label55) ? _tmp64_label55 : (_tmp64_label55 = g_quark_from_static_string ("KP_End"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_x = (guint8) (self->priv->game_size - 1);
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label56) ? _tmp64_label56 : (_tmp64_label56 = g_quark_from_static_string ("Page_Up")))) || (_tmp65_ == ((0 != _tmp64_label57) ? _tmp64_label57 : (_tmp64_label57 = g_quark_from_static_string ("KP_Page_Up"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) 0;
				break;
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label58) ? _tmp64_label58 : (_tmp64_label58 = g_quark_from_static_string ("Page_Down")))) || (_tmp65_ == ((0 != _tmp64_label59) ? _tmp64_label59 : (_tmp64_label59 = g_quark_from_static_string ("KP_Next"))))) {
		switch (0) {
			default:
			{
				self->priv->highlight_y = (guint8) (self->priv->game_size - 1);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				result = FALSE;
				_g_free0 (key);
				return result;
			}
		}
	}
	self->priv->highlight_set = TRUE;
	_tmp88_ = key;
	if (g_strcmp0 (_tmp88_, "Escape") == 0) {
		self->priv->show_highlight = FALSE;
	} else {
		if (self->priv->show_highlight) {
			self->priv->highlight_state = GAME_VIEW_HIGHLIGHT_MAX;
		} else {
			self->priv->show_highlight = TRUE;
		}
	}
	_tmp89_ = game_view_get_board_x (self);
	_tmp90_ = _tmp89_;
	_tmp91_ = game_view_get_board_y (self);
	_tmp92_ = _tmp91_;
	gtk_widget_queue_draw_area ((GtkWidget*) self, (gint) (_tmp90_ + (old_highlight_x * self->priv->paving_size)), (gint) (_tmp92_ + (old_highlight_y * self->priv->paving_size)), self->priv->tile_size, self->priv->tile_size);
	if (old_highlight_x != self->priv->highlight_x) {
		_tmp93_ = TRUE;
	} else {
		_tmp93_ = old_highlight_y != self->priv->highlight_y;
	}
	if (_tmp93_) {
		gint _tmp94_;
		gint _tmp95_;
		gint _tmp96_;
		gint _tmp97_;
		_tmp94_ = game_view_get_board_x (self);
		_tmp95_ = _tmp94_;
		_tmp96_ = game_view_get_board_y (self);
		_tmp97_ = _tmp96_;
		gtk_widget_queue_draw_area ((GtkWidget*) self, (gint) (_tmp95_ + (self->priv->highlight_x * self->priv->paving_size)), (gint) (_tmp97_ + (self->priv->highlight_y * self->priv->paving_size)), self->priv->tile_size, self->priv->tile_size);
	}
	result = TRUE;
	_g_free0 (key);
	return result;
}

static gboolean
game_view_draw_scoreboard (GameView* self,
                           cairo_t* cr)
{
	gboolean result = FALSE;
	gint height = 0;
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
	gint width = 0;
	GtkDrawingArea* _tmp2_;
	GtkDrawingArea* _tmp3_;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_t* c = NULL;
	cairo_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	cairo_matrix_t matrix = {0};
	cairo_pattern_t* _tmp8_;
	cairo_matrix_t _tmp9_;
	cairo_pattern_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_matrix_t _tmp12_;
	cairo_pattern_t* _tmp13_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = game_view_get_scoreboard (self);
	_tmp1_ = _tmp0_;
	height = gtk_widget_get_allocated_height ((GtkWidget*) _tmp1_);
	_tmp2_ = game_view_get_scoreboard (self);
	_tmp3_ = _tmp2_;
	width = gtk_widget_get_allocated_width ((GtkWidget*) _tmp3_);
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
	cairo_save (cr);
	cairo_set_source_rgba (cr, self->priv->mark_red, self->priv->mark_green, self->priv->mark_blue, 1.0);
	cairo_set_line_width (cr, (gdouble) self->priv->mark_width);
	cairo_translate (cr, (gdouble) 0, (self->priv->current_player_number * height) / 2.0);
	cairo_move_to (cr, height / 4.0, height / 8.0);
	cairo_line_to (cr, width - ((5.0 * height) / 8.0), height / 4.0);
	cairo_line_to (cr, height / 4.0, (3.0 * height) / 8.0);
	cairo_stroke (cr);
	cairo_restore (cr);
	_tmp4_ = cairo_get_target (cr);
	_tmp5_ = cairo_surface_create_similar (_tmp4_, CAIRO_CONTENT_COLOR_ALPHA, height * 4, height * 2);
	surface = _tmp5_;
	_tmp6_ = cairo_create (surface);
	c = _tmp6_;
	game_view_load_image (self, c, height * 4, height * 2);
	_tmp7_ = cairo_pattern_create_for_surface (surface);
	_cairo_pattern_destroy0 (self->priv->scoreboard_tiles_pattern);
	self->priv->scoreboard_tiles_pattern = _tmp7_;
	cairo_translate (cr, width - (height / 2.0), (gdouble) 0);
	cairo_matrix_init_identity (&matrix);
	cairo_matrix_translate (&matrix, height / 2.0, (gdouble) 0);
	_tmp8_ = self->priv->scoreboard_tiles_pattern;
	_tmp9_ = matrix;
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp8_, &_tmp9_);
	_tmp10_ = self->priv->scoreboard_tiles_pattern;
	cairo_set_source (cr, (cairo_pattern_t*) _tmp10_);
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, height / 2.0, height / 2.0);
	cairo_fill (cr);
	cairo_matrix_translate (&matrix, (gdouble) (3 * height), (gdouble) height);
	_tmp11_ = self->priv->scoreboard_tiles_pattern;
	_tmp12_ = matrix;
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp11_, &_tmp12_);
	_tmp13_ = self->priv->scoreboard_tiles_pattern;
	cairo_set_source (cr, (cairo_pattern_t*) _tmp13_);
	cairo_rectangle (cr, (gdouble) 0, height / 2.0, height / 2.0, height / 2.0);
	cairo_fill (cr);
	result = TRUE;
	_cairo_destroy0 (c);
	_cairo_surface_destroy0 (surface);
	return result;
}

void
game_view_update_scoreboard (GameView* self)
{
	gint _tmp0_ = 0;
	Game* _tmp1_;
	Game* _tmp2_;
	Player _tmp3_;
	Player _tmp4_;
	GtkDrawingArea* _tmp5_;
	GtkDrawingArea* _tmp6_;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
	_tmp1_ = game_view_get_game (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = game_get_current_color (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == PLAYER_DARK) {
		_tmp0_ = 0;
	} else {
		_tmp0_ = 1;
	}
	self->priv->current_player_number = _tmp0_;
	_tmp5_ = game_view_get_scoreboard (self);
	_tmp6_ = _tmp5_;
	gtk_widget_queue_draw ((GtkWidget*) _tmp6_);
}

GameView*
game_view_construct (GType object_type)
{
	GameView * self = NULL;
	self = (GameView*) g_object_new (object_type, NULL);
	return self;
}

GameView*
game_view_new (void)
{
	return game_view_construct (TYPE_GAME_VIEW);
}

static GtkDrawingArea*
game_view_get_scoreboard (GameView* self)
{
	GtkDrawingArea* result;
	GtkDrawingArea* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_scoreboard;
	result = _tmp0_;
	return result;
}

static gboolean
_game_view_draw_scoreboard_gtk_widget_draw (GtkWidget* _sender,
                                            cairo_t* cr,
                                            gpointer self)
{
	gboolean result;
	result = game_view_draw_scoreboard ((GameView*) self, cr);
	return result;
}

void
game_view_set_scoreboard (GameView* self,
                          GtkDrawingArea* value)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_scoreboard);
	self->priv->_scoreboard = _tmp0_;
	_tmp1_ = self->priv->_scoreboard;
	g_signal_connect_object ((GtkWidget*) _tmp1_, "draw", (GCallback) _game_view_draw_scoreboard_gtk_widget_draw, self, 0);
}

const gchar*
game_view_get_sound_flip (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sound_flip;
	result = _tmp0_;
	return result;
}

static void
game_view_set_sound_flip (GameView* self,
                          const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_sound_flip);
	self->priv->_sound_flip = _tmp0_;
}

const gchar*
game_view_get_sound_gameover (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_sound_gameover;
	result = _tmp0_;
	return result;
}

static void
game_view_set_sound_gameover (GameView* self,
                              const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_sound_gameover);
	self->priv->_sound_gameover = _tmp0_;
}

static gint
game_view_get_board_x (GameView* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gtk_widget_get_allocated_width ((GtkWidget*) self) - self->priv->board_size) / 2;
	return result;
}

static gint
game_view_get_board_y (GameView* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gtk_widget_get_allocated_height ((GtkWidget*) self) - self->priv->board_size) / 2;
	return result;
}

Game*
game_view_get_game (GameView* self)
{
	Game* result;
	Game* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	if (!self->priv->game_is_set) {
		g_assert_not_reached ();
	}
	_tmp0_ = self->priv->_game;
	result = _tmp0_;
	return result;
}

static void
_game_view_game_is_complete_cb_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	game_view_game_is_complete_cb ((GameView*) self);
}

static void
_game_view_square_changed_cb_game_square_changed (Game* _sender,
                                                  guint8 x,
                                                  guint8 y,
                                                  Player new_color,
                                                  gpointer self)
{
	game_view_square_changed_cb ((GameView*) self, x, y, new_color);
}

void
game_view_set_game (GameView* self,
                    Game* value)
{
	Game* test = NULL;
	Game* _tmp0_;
	Game* _tmp2_;
	Game* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gint* _tmp6_;
	Game* _tmp13_;
	Game* _tmp14_;
	gboolean odd_game = FALSE;
	gboolean _tmp15_ = FALSE;
	Game* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	guint8 _tmp19_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	test = _tmp0_;
	if (test == NULL) {
		g_assert_not_reached ();
	}
	if (self->priv->game_is_set) {
		Game* _tmp1_;
		_tmp1_ = self->priv->_game;
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
	}
	_tmp2_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_game);
	self->priv->_game = _tmp2_;
	self->priv->game_is_set = TRUE;
	_tmp3_ = self->priv->_game;
	_tmp4_ = game_get_size (_tmp3_);
	_tmp5_ = _tmp4_;
	self->priv->game_size = _tmp5_;
	_tmp6_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
	self->priv->pixmaps = _tmp6_;
	self->priv->pixmaps_length1 = self->priv->game_size;
	self->priv->pixmaps_length2 = self->priv->game_size;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				if (!_tmp7_) {
					guint8 _tmp8_;
					_tmp8_ = x;
					x = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				if (!(x < self->priv->game_size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							gint* _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							Game* _tmp12_;
							if (!_tmp9_) {
								guint8 _tmp10_;
								_tmp10_ = y;
								y = _tmp10_ + 1;
							}
							_tmp9_ = FALSE;
							if (!(y < self->priv->game_size)) {
								break;
							}
							_tmp11_ = self->priv->pixmaps;
							_tmp11__length1 = self->priv->pixmaps_length1;
							_tmp11__length2 = self->priv->pixmaps_length2;
							_tmp12_ = self->priv->_game;
							_tmp11_[(x * _tmp11__length2) + y] = game_view_get_pixmap (game_get_owner (_tmp12_, x, y));
						}
					}
				}
			}
		}
	}
	_tmp13_ = self->priv->_game;
	g_signal_connect_object ((GObject*) _tmp13_, "notify::is-complete", (GCallback) _game_view_game_is_complete_cb_g_object_notify, self, 0);
	_tmp14_ = self->priv->_game;
	g_signal_connect_object (_tmp14_, "square-changed", (GCallback) _game_view_square_changed_cb_game_square_changed, self, 0);
	self->priv->show_highlight = FALSE;
	odd_game = (self->priv->game_size % 2) != 0;
	_tmp16_ = self->priv->_game;
	_tmp17_ = game_get_alternative_start (_tmp16_);
	_tmp18_ = _tmp17_;
	if (_tmp18_) {
		_tmp15_ = TRUE;
	} else {
		_tmp15_ = odd_game;
	}
	self->priv->highlight_set = _tmp15_;
	if (odd_game) {
		_tmp19_ = (guint8) (self->priv->game_size / 2);
	} else {
		_tmp19_ = (guint8) ((self->priv->game_size / 2) - 1);
	}
	self->priv->highlight_x = _tmp19_;
	self->priv->highlight_y = self->priv->highlight_x;
	self->priv->highlight_state = (guint8) 0;
	gtk_widget_queue_draw ((GtkWidget*) self);
	_g_object_unref0 (test);
}

const gchar*
game_view_get_theme (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_theme;
	result = _tmp0_;
	return result;
}

void
game_view_set_theme (GameView* self,
                     const gchar* value)
{
	GKeyFile* key = NULL;
	GKeyFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp15_;
	gchar* _tmp16_;
	GtkDrawingArea* _tmp17_;
	GtkDrawingArea* _tmp18_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_key_file_new ();
	key = _tmp0_;
	if (value == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = g_strcmp0 ((const gchar*) value, "default") == 0;
	}
	if (_tmp1_) {
		game_view_set_default_theme (self, &key);
	} else {
		{
			gchar* key_path = NULL;
			gchar* _tmp2_;
			gchar* filepath = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gboolean _tmp9_;
			GKeyFile* _tmp11_;
			const gchar* _tmp12_;
			_tmp2_ = g_build_filename (DATA_DIRECTORY, "themes", "key", NULL);
			key_path = _tmp2_;
			_tmp3_ = key_path;
			_tmp4_ = g_build_filename (_tmp3_, (const gchar*) value, NULL);
			filepath = _tmp4_;
			_tmp5_ = filepath;
			_tmp6_ = g_path_get_dirname (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = key_path;
			_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
			_g_free0 (_tmp7_);
			if (_tmp9_) {
				GError* _tmp10_;
				_tmp10_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Theme file is not in the \"key\" directory.");
				_inner_error0_ = _tmp10_;
				_g_free0 (filepath);
				_g_free0 (key_path);
				goto __catch4_g_error;
			}
			_tmp11_ = key;
			_tmp12_ = filepath;
			g_key_file_load_from_file (_tmp11_, _tmp12_, G_KEY_FILE_NONE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (filepath);
				_g_free0 (key_path);
				goto __catch4_g_error;
			}
			_g_free0 (filepath);
			_g_free0 (key_path);
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp13_ = e;
			_tmp14_ = _tmp13_->message;
			g_warning ("game-view.vala:168: Failed to load theme: %s", _tmp14_);
			game_view_set_default_theme (self, &key);
			value = "default";
			_g_error_free0 (e);
		}
		__finally4:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_key_file_unref0 (key);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp15_ = key;
	game_view_load_theme (self, _tmp15_);
	_tmp16_ = g_strdup (value);
	_g_free0 (self->priv->_theme);
	self->priv->_theme = _tmp16_;
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
	self->priv->tiles_pattern = NULL;
	_tmp17_ = game_view_get_scoreboard (self);
	_tmp18_ = _tmp17_;
	gtk_widget_queue_draw ((GtkWidget*) _tmp18_);
	gtk_widget_queue_draw ((GtkWidget*) self);
	_g_key_file_unref0 (key);
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
}

static GObject *
game_view_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GameView * self;
	parent_class = G_OBJECT_CLASS (game_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_VIEW, GameView);
	gtk_widget_set_events ((GtkWidget*) self, (gint) ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK));
	gtk_widget_set_size_request ((GtkWidget*) self, 350, 350);
	return obj;
}

static void
game_view_class_init (GameViewClass * klass,
                      gpointer klass_data)
{
	game_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GameView_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) game_view_real_draw;
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) game_view_real_button_press_event;
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) game_view_real_key_press_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_game_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_game_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = game_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = game_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SCOREBOARD_PROPERTY, game_view_properties[GAME_VIEW_SCOREBOARD_PROPERTY] = g_param_spec_object ("scoreboard", "scoreboard", "scoreboard", gtk_drawing_area_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SOUND_FLIP_PROPERTY, game_view_properties[GAME_VIEW_SOUND_FLIP_PROPERTY] = g_param_spec_string ("sound-flip", "sound-flip", "sound-flip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SOUND_GAMEOVER_PROPERTY, game_view_properties[GAME_VIEW_SOUND_GAMEOVER_PROPERTY] = g_param_spec_string ("sound-gameover", "sound-gameover", "sound-gameover", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_GAME_PROPERTY, game_view_properties[GAME_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_THEME_PROPERTY, game_view_properties[GAME_VIEW_THEME_PROPERTY] = g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
	game_view_signals[GAME_VIEW_MOVE_SIGNAL] = g_signal_new ("move", TYPE_GAME_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
}

static void
game_view_instance_init (GameView * self,
                         gpointer klass)
{
	self->priv = game_view_get_instance_private (self);
	self->priv->background_red = 0.2;
	self->priv->background_green = 0.6;
	self->priv->background_blue = 0.4;
	self->priv->background_radius = 0;
	self->priv->mark_red = 0.2;
	self->priv->mark_green = 0.6;
	self->priv->mark_blue = 0.4;
	self->priv->mark_width = 2;
	self->priv->border_red = 0.1;
	self->priv->border_green = 0.1;
	self->priv->border_blue = 0.1;
	self->priv->border_width = 3;
	self->priv->spacing_red = 0.1;
	self->priv->spacing_green = 0.3;
	self->priv->spacing_blue = 0.2;
	self->priv->spacing_width = 2;
	self->priv->highlight_red = 0.1;
	self->priv->highlight_green = 0.3;
	self->priv->highlight_blue = 0.2;
	self->priv->highlight_alpha = 0.4;
	self->priv->render_size = (guint) 0;
	self->priv->tiles_pattern = NULL;
	self->priv->scoreboard_tiles_pattern = NULL;
	self->priv->animate_timeout = (guint) 0;
	self->priv->current_player_number = 0;
	self->priv->game_is_set = FALSE;
	self->priv->_theme = NULL;
	self->priv->flip_final_result_now = FALSE;
}

static void
game_view_finalize (GObject * obj)
{
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_VIEW, GameView);
	_g_object_unref0 (self->priv->_scoreboard);
	_g_free0 (self->priv->pieces_file);
	_g_free0 (self->priv->_sound_flip);
	_g_free0 (self->priv->_sound_gameover);
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
	_cairo_pattern_destroy0 (self->priv->scoreboard_tiles_pattern);
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
	_g_object_unref0 (self->priv->_game);
	_g_free0 (self->priv->_theme);
	G_OBJECT_CLASS (game_view_parent_class)->finalize (obj);
}

GType
game_view_get_type (void)
{
	static volatile gsize game_view_type_id__volatile = 0;
	if (g_once_init_enter (&game_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameView), 0, (GInstanceInitFunc) game_view_instance_init, NULL };
		GType game_view_type_id;
		game_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GameView", &g_define_type_info, 0);
		GameView_private_offset = g_type_add_instance_private (game_view_type_id, sizeof (GameViewPrivate));
		g_once_init_leave (&game_view_type_id__volatile, game_view_type_id);
	}
	return game_view_type_id__volatile;
}

static void
_vala_game_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_VIEW, GameView);
	switch (property_id) {
		case GAME_VIEW_SCOREBOARD_PROPERTY:
		g_value_set_object (value, game_view_get_scoreboard (self));
		break;
		case GAME_VIEW_SOUND_FLIP_PROPERTY:
		g_value_set_string (value, game_view_get_sound_flip (self));
		break;
		case GAME_VIEW_SOUND_GAMEOVER_PROPERTY:
		g_value_set_string (value, game_view_get_sound_gameover (self));
		break;
		case GAME_VIEW_GAME_PROPERTY:
		g_value_set_object (value, game_view_get_game (self));
		break;
		case GAME_VIEW_THEME_PROPERTY:
		g_value_set_string (value, game_view_get_theme (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_game_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_VIEW, GameView);
	switch (property_id) {
		case GAME_VIEW_SCOREBOARD_PROPERTY:
		game_view_set_scoreboard (self, g_value_get_object (value));
		break;
		case GAME_VIEW_SOUND_FLIP_PROPERTY:
		game_view_set_sound_flip (self, g_value_get_string (value));
		break;
		case GAME_VIEW_SOUND_GAMEOVER_PROPERTY:
		game_view_set_sound_gameover (self, g_value_get_string (value));
		break;
		case GAME_VIEW_GAME_PROPERTY:
		game_view_set_game (self, g_value_get_object (value));
		break;
		case GAME_VIEW_THEME_PROPERTY:
		game_view_set_theme (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

