/* game-window.c generated by valac 0.44.7, the Vala compiler
 * generated from game-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2015, 2016, 2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	GAME_WINDOW_FLAGS_SHOW_UNDO = 1 << 0,
	GAME_WINDOW_FLAGS_SHOW_START_BUTTON = 1 << 1
} GameWindowFlags;

#define TYPE_GAME_WINDOW_FLAGS (game_window_flags_get_type ())

#define TYPE_GAME_WINDOW (game_window_get_type ())
#define GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_WINDOW, GameWindow))
#define GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_WINDOW, GameWindowClass))
#define IS_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_WINDOW))
#define IS_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_WINDOW))
#define GAME_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_WINDOW, GameWindowClass))

typedef struct _GameWindow GameWindow;
typedef struct _GameWindowClass GameWindowClass;
typedef struct _GameWindowPrivate GameWindowPrivate;
enum  {
	GAME_WINDOW_0_PROPERTY,
	GAME_WINDOW_NUM_PROPERTIES
};
static GParamSpec* game_window_properties[GAME_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GAME_WINDOW_PLAY_SIGNAL,
	GAME_WINDOW_WAIT_SIGNAL,
	GAME_WINDOW_BACK_SIGNAL,
	GAME_WINDOW_UNDO_SIGNAL,
	GAME_WINDOW_NUM_SIGNALS
};
static guint game_window_signals[GAME_WINDOW_NUM_SIGNALS] = {0};

struct _GameWindow {
	GtkApplicationWindow parent_instance;
	GameWindowPrivate * priv;
};

struct _GameWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _GameWindowPrivate {
	gboolean window_is_tiled;
	gboolean window_is_maximized;
	gboolean window_is_fullscreen;
	gint window_width;
	gint window_height;
	gboolean game_finished;
	GtkHeaderBar* headerbar;
	GtkStack* stack;
	GtkButton* start_game_button;
	GtkButton* new_game_button;
	GtkButton* back_button;
	GtkButton* unfullscreen_button;
	GtkBox* controls_box;
	GtkBox* game_box;
	GtkBox* new_game_box;
	GtkBox* side_box;
	GtkWidget* view;
	GSimpleAction* back_action;
	GSimpleAction* undo_action;
	GtkMenuButton* info_button;
};

static gint GameWindow_private_offset;
static gpointer game_window_parent_class = NULL;

GType game_window_flags_get_type (void) G_GNUC_CONST;
GType game_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameWindow, g_object_unref)
static void game_window_new_game_cb (GameWindow* self);
static void _game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void game_window_start_game_cb (GameWindow* self);
static void _game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void game_window_back_cb (GameWindow* self);
static void _game_window_back_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_undo_cb (GameWindow* self);
static void _game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_toggle_hamburger (GameWindow* self);
static void _game_window_toggle_hamburger_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void _gtk_window_unfullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
GameWindow* game_window_new (const gchar* css_resource,
                             const gchar* name,
                             gint width,
                             gint height,
                             gboolean maximized,
                             gboolean start_now,
                             GameWindowFlags flags,
                             GtkBox* new_game_screen,
                             GtkWidget* _view);
GameWindow* game_window_construct (GType object_type,
                                   const gchar* css_resource,
                                   const gchar* name,
                                   gint width,
                                   gint height,
                                   gboolean maximized,
                                   gboolean start_now,
                                   GameWindowFlags flags,
                                   GtkBox* new_game_screen,
                                   GtkWidget* _view);
static void game_window_install_ui_action_entries (GameWindow* self);
static void game_window_size_allocate_cb (GameWindow* self);
static void _game_window_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender,
                                                             GtkAllocation* allocation,
                                                             gpointer self);
static gboolean game_window_window_state_event_cb (GameWindow* self,
                                            GdkEventWindowState* event);
static gboolean _game_window_window_state_event_cb_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                           GdkEventWindowState* event,
                                                                           gpointer self);
static void game_window_show_view (GameWindow* self);
static void game_window_show_new_game_screen (GameWindow* self);
void game_window_shutdown (GameWindow* self,
                           GSettings* settings);
void game_window_add_to_sidebox (GameWindow* self,
                                 GtkWidget* widget);
void game_window_cannot_undo_more (GameWindow* self);
void game_window_new_turn_start (GameWindow* self,
                                 gboolean can_undo);
void game_window_set_subtitle (GameWindow* self,
                               const gchar* subtitle);
void game_window_finish_game (GameWindow* self);
static void game_window_finalize (GObject * obj);

static const GActionEntry GAME_WINDOW_ui_action_entries[6] = {{"new-game", _game_window_new_game_cb_gsimple_action_activate_callback}, {"start-game", _game_window_start_game_cb_gsimple_action_activate_callback}, {"back", _game_window_back_cb_gsimple_action_activate_callback}, {"undo", _game_window_undo_cb_gsimple_action_activate_callback}, {"toggle-hamburger", _game_window_toggle_hamburger_gsimple_action_activate_callback}, {"unfullscreen", _gtk_window_unfullscreen_gsimple_action_activate_callback}};

GType
game_window_flags_get_type (void)
{
	static volatile gsize game_window_flags_type_id__volatile = 0;
	if (g_once_init_enter (&game_window_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{GAME_WINDOW_FLAGS_SHOW_UNDO, "GAME_WINDOW_FLAGS_SHOW_UNDO", "show-undo"}, {GAME_WINDOW_FLAGS_SHOW_START_BUTTON, "GAME_WINDOW_FLAGS_SHOW_START_BUTTON", "show-start-button"}, {0, NULL, NULL}};
		GType game_window_flags_type_id;
		game_window_flags_type_id = g_flags_register_static ("GameWindowFlags", values);
		g_once_init_leave (&game_window_flags_type_id__volatile, game_window_flags_type_id);
	}
	return game_window_flags_type_id__volatile;
}

static inline gpointer
game_window_get_instance_private (GameWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GameWindow_private_offset);
}

static void
_game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
	game_window_new_game_cb ((GameWindow*) self);
}

static void
_game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
	game_window_start_game_cb ((GameWindow*) self);
}

static void
_game_window_back_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
	game_window_back_cb ((GameWindow*) self);
}

static void
_game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
	game_window_undo_cb ((GameWindow*) self);
}

static void
_game_window_toggle_hamburger_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
	game_window_toggle_hamburger ((GameWindow*) self);
}

static void
_gtk_window_unfullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
	gtk_window_unfullscreen ((GtkWindow*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_game_window_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender,
                                                        GtkAllocation* allocation,
                                                        gpointer self)
{
	game_window_size_allocate_cb ((GameWindow*) self);
}

static gboolean
_game_window_window_state_event_cb_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                  GdkEventWindowState* event,
                                                                  gpointer self)
{
	gboolean result;
	result = game_window_window_state_event_cb ((GameWindow*) self, event);
	return result;
}

GameWindow*
game_window_construct (GType object_type,
                       const gchar* css_resource,
                       const gchar* name,
                       gint width,
                       gint height,
                       gboolean maximized,
                       gboolean start_now,
                       GameWindowFlags flags,
                       GtkBox* new_game_screen,
                       GtkWidget* _view)
{
	GameWindow * self = NULL;
	GtkWidget* _tmp7_;
	GtkHeaderBar* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp22_;
	GtkWidget* _tmp23_;
	GtkBox* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	GtkWidget* _tmp27_;
	GtkWidget* _tmp28_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (new_game_screen != NULL, NULL);
	g_return_val_if_fail (_view != NULL, NULL);
	self = (GameWindow*) g_object_new (object_type, NULL);
	if (css_resource != NULL) {
		GtkCssProvider* css_provider = NULL;
		GtkCssProvider* _tmp0_;
		GtkCssProvider* _tmp1_;
		GdkScreen* gdk_screen = NULL;
		GdkScreen* _tmp2_;
		GdkScreen* _tmp3_;
		GdkScreen* _tmp4_;
		_tmp0_ = gtk_css_provider_new ();
		css_provider = _tmp0_;
		_tmp1_ = css_provider;
		gtk_css_provider_load_from_resource (_tmp1_, (const gchar*) css_resource);
		_tmp2_ = gdk_screen_get_default ();
		_tmp3_ = _g_object_ref0 (_tmp2_);
		gdk_screen = _tmp3_;
		_tmp4_ = gdk_screen;
		if (_tmp4_ != NULL) {
			GdkScreen* _tmp5_;
			GtkCssProvider* _tmp6_;
			_tmp5_ = gdk_screen;
			_tmp6_ = css_provider;
			gtk_style_context_add_provider_for_screen (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gdk_screen_get_type (), GdkScreen), (GtkStyleProvider*) _tmp6_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
		}
		_g_object_unref0 (gdk_screen);
		_g_object_unref0 (css_provider);
	}
	_tmp7_ = _g_object_ref0 (_view);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp7_;
	game_window_install_ui_action_entries (self);
	gtk_window_set_title ((GtkWindow*) self, name);
	_tmp8_ = self->priv->headerbar;
	gtk_header_bar_set_title (_tmp8_, name);
	gtk_window_set_default_size ((GtkWindow*) self, width, height);
	if (maximized) {
		gtk_window_maximize ((GtkWindow*) self);
	}
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _game_window_size_allocate_cb_gtk_widget_size_allocate, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "window-state-event", (GCallback) _game_window_window_state_event_cb_gtk_widget_window_state_event, self, 0);
	_tmp9_ = self->priv->new_game_box;
	gtk_box_pack_start (_tmp9_, (GtkWidget*) new_game_screen, TRUE, TRUE, (guint) 0);
	if ((flags & GAME_WINDOW_FLAGS_SHOW_START_BUTTON) == GAME_WINDOW_FLAGS_SHOW_START_BUTTON) {
		GtkButton* _start_game_button = NULL;
		GtkButton* _tmp10_;
		GtkButton* _tmp11_;
		GtkButton* _tmp12_;
		GtkButton* _tmp13_;
		GtkButton* _tmp14_;
		GtkButton* _tmp15_;
		GtkStyleContext* _tmp16_;
		GtkButton* _tmp17_;
		GtkBox* _tmp18_;
		GtkButton* _tmp19_;
		GtkButton* _tmp20_;
		GtkButton* _tmp21_;
		_tmp10_ = (GtkButton*) gtk_button_new_with_mnemonic (_ ("_Start Game"));
		g_object_ref_sink (_tmp10_);
		_start_game_button = _tmp10_;
		_tmp11_ = _start_game_button;
		g_object_set ((GtkWidget*) _tmp11_, "width-request", 222, NULL);
		_tmp12_ = _start_game_button;
		g_object_set ((GtkWidget*) _tmp12_, "height-request", 60, NULL);
		_tmp13_ = _start_game_button;
		gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
		_tmp14_ = _start_game_button;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp14_, "ui.start-game");
		_tmp15_ = _start_game_button;
		_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
		gtk_style_context_add_class (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_style_context_get_type (), GtkStyleContext), "suggested-action");
		_tmp17_ = _start_game_button;
		gtk_widget_show ((GtkWidget*) _tmp17_);
		_tmp18_ = self->priv->new_game_box;
		_tmp19_ = _start_game_button;
		gtk_box_pack_end (_tmp18_, (GtkWidget*) _tmp19_, FALSE, FALSE, (guint) 0);
		_tmp20_ = _start_game_button;
		_tmp21_ = _g_object_ref0 (_tmp20_);
		_g_object_unref0 (self->priv->start_game_button);
		self->priv->start_game_button = _tmp21_;
		_g_object_unref0 (_start_game_button);
	}
	_tmp22_ = self->priv->game_box;
	_tmp23_ = self->priv->view;
	gtk_box_pack_start (_tmp22_, _tmp23_, TRUE, TRUE, (guint) 0);
	_tmp24_ = self->priv->game_box;
	_tmp25_ = self->priv->view;
	gtk_container_set_focus_child ((GtkContainer*) _tmp24_, _tmp25_);
	_tmp26_ = self->priv->view;
	gtk_widget_set_halign (_tmp26_, GTK_ALIGN_FILL);
	_tmp27_ = self->priv->view;
	gtk_widget_set_can_focus (_tmp27_, TRUE);
	_tmp28_ = self->priv->view;
	gtk_widget_show (_tmp28_);
	if ((flags & GAME_WINDOW_FLAGS_SHOW_UNDO) == GAME_WINDOW_FLAGS_SHOW_UNDO) {
		GtkBox* history_box = NULL;
		GtkBox* _tmp29_;
		GtkBox* _tmp30_;
		GtkStyleContext* _tmp31_;
		GtkButton* undo_button = NULL;
		GtkButton* _tmp32_;
		GtkButton* _tmp33_;
		GtkButton* _tmp34_;
		GtkButton* _tmp35_;
		GtkButton* _tmp36_;
		GtkBox* _tmp37_;
		GtkButton* _tmp38_;
		GtkBox* _tmp39_;
		GtkBox* _tmp40_;
		GtkBox* _tmp41_;
		_tmp29_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
		g_object_ref_sink (_tmp29_);
		history_box = _tmp29_;
		_tmp30_ = history_box;
		_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
		gtk_style_context_add_class (_tmp31_, "linked");
		_tmp32_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
		g_object_ref_sink (_tmp32_);
		undo_button = _tmp32_;
		_tmp33_ = undo_button;
		gtk_actionable_set_action_name ((GtkActionable*) _tmp33_, "ui.undo");
		_tmp34_ = undo_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp34_, _ ("Undo your most recent move"));
		_tmp35_ = undo_button;
		gtk_widget_set_valign ((GtkWidget*) _tmp35_, GTK_ALIGN_CENTER);
		_tmp36_ = undo_button;
		gtk_widget_show ((GtkWidget*) _tmp36_);
		_tmp37_ = history_box;
		_tmp38_ = undo_button;
		gtk_box_pack_start (_tmp37_, (GtkWidget*) _tmp38_, TRUE, TRUE, (guint) 0);
		_tmp39_ = history_box;
		gtk_widget_show ((GtkWidget*) _tmp39_);
		_tmp40_ = self->priv->controls_box;
		_tmp41_ = history_box;
		gtk_box_pack_start (_tmp40_, (GtkWidget*) _tmp41_, TRUE, TRUE, (guint) 0);
		_g_object_unref0 (undo_button);
		_g_object_unref0 (history_box);
	}
	if (start_now) {
		game_window_show_view (self);
	} else {
		game_window_show_new_game_screen (self);
	}
	return self;
}

GameWindow*
game_window_new (const gchar* css_resource,
                 const gchar* name,
                 gint width,
                 gint height,
                 gboolean maximized,
                 gboolean start_now,
                 GameWindowFlags flags,
                 GtkBox* new_game_screen,
                 GtkWidget* _view)
{
	return game_window_construct (TYPE_GAME_WINDOW, css_resource, name, width, height, maximized, start_now, flags, new_game_screen, _view);
}

static void
game_window_install_ui_action_entries (GameWindow* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_simple_action_group_new ();
	action_group = _tmp0_;
	g_action_map_add_action_entries ((GActionMap*) action_group, GAME_WINDOW_ui_action_entries, (gint) G_N_ELEMENTS (GAME_WINDOW_ui_action_entries), self);
	gtk_widget_insert_action_group ((GtkWidget*) self, "ui", (GActionGroup*) action_group);
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) action_group, "back");
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
	_g_object_unref0 (self->priv->back_action);
	self->priv->back_action = _tmp2_;
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) action_group, "undo");
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction));
	_g_object_unref0 (self->priv->undo_action);
	self->priv->undo_action = _tmp4_;
	_tmp5_ = self->priv->back_action;
	g_simple_action_set_enabled (_tmp5_, FALSE);
	_tmp6_ = self->priv->undo_action;
	g_simple_action_set_enabled (_tmp6_, FALSE);
	_g_object_unref0 (action_group);
}

static void
game_window_size_allocate_cb (GameWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	g_return_if_fail (self != NULL);
	if (self->priv->window_is_maximized) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = self->priv->window_is_tiled;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->window_is_fullscreen;
	}
	if (_tmp0_) {
		return;
	}
	gtk_window_get_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
	self->priv->window_width = _tmp2_;
	self->priv->window_height = _tmp3_;
}

static gboolean
game_window_window_state_event_cb (GameWindow* self,
                                   GdkEventWindowState* event)
{
	gboolean result = FALSE;
	GdkWindowState _tmp0_;
	gboolean window_was_fullscreen = FALSE;
	GdkWindowState _tmp2_;
	gboolean _tmp4_ = FALSE;
	GdkWindowState tiled_state = 0U;
	GdkWindowState _tmp8_;
	GdkWindowState _tmp9_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->changed_mask;
	if ((_tmp0_ & GDK_WINDOW_STATE_MAXIMIZED) != 0) {
		GdkWindowState _tmp1_;
		_tmp1_ = event->new_window_state;
		self->priv->window_is_maximized = (_tmp1_ & GDK_WINDOW_STATE_MAXIMIZED) != 0;
	}
	window_was_fullscreen = self->priv->window_is_fullscreen;
	_tmp2_ = event->changed_mask;
	if ((_tmp2_ & GDK_WINDOW_STATE_FULLSCREEN) != 0) {
		GdkWindowState _tmp3_;
		_tmp3_ = event->new_window_state;
		self->priv->window_is_fullscreen = (_tmp3_ & GDK_WINDOW_STATE_FULLSCREEN) != 0;
	}
	if (window_was_fullscreen) {
		_tmp4_ = !self->priv->window_is_fullscreen;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GtkButton* _tmp5_;
		_tmp5_ = self->priv->unfullscreen_button;
		gtk_widget_hide ((GtkWidget*) _tmp5_);
	} else {
		gboolean _tmp6_ = FALSE;
		if (!window_was_fullscreen) {
			_tmp6_ = self->priv->window_is_fullscreen;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			GtkButton* _tmp7_;
			_tmp7_ = self->priv->unfullscreen_button;
			gtk_widget_show ((GtkWidget*) _tmp7_);
		}
	}
	tiled_state = (((GDK_WINDOW_STATE_TILED | GDK_WINDOW_STATE_TOP_TILED) | GDK_WINDOW_STATE_BOTTOM_TILED) | GDK_WINDOW_STATE_LEFT_TILED) | GDK_WINDOW_STATE_RIGHT_TILED;
	_tmp8_ = event->changed_mask;
	_tmp9_ = tiled_state;
	if ((_tmp8_ & _tmp9_) != 0) {
		GdkWindowState _tmp10_;
		GdkWindowState _tmp11_;
		_tmp10_ = event->new_window_state;
		_tmp11_ = tiled_state;
		self->priv->window_is_tiled = (_tmp10_ & _tmp11_) != 0;
	}
	result = FALSE;
	return result;
}

void
game_window_shutdown (GameWindow* self,
                      GSettings* settings)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (settings != NULL);
	g_settings_delay (settings);
	g_settings_set_int (settings, "window-width", self->priv->window_width);
	g_settings_set_int (settings, "window-height", self->priv->window_height);
	if (self->priv->window_is_maximized) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->window_is_fullscreen;
	}
	g_settings_set_boolean (settings, "window-is-maximized", _tmp0_);
	g_settings_apply (settings);
	gtk_widget_destroy ((GtkWidget*) self);
}

void
game_window_add_to_sidebox (GameWindow* self,
                            GtkWidget* widget)
{
	GtkBox* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = self->priv->side_box;
	gtk_box_pack_start (_tmp0_, widget, FALSE, FALSE, (guint) 0);
}

void
game_window_cannot_undo_more (GameWindow* self)
{
	GSimpleAction* _tmp0_;
	GtkWidget* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undo_action;
	g_simple_action_set_enabled (_tmp0_, FALSE);
	_tmp1_ = self->priv->view;
	gtk_widget_grab_focus (_tmp1_);
}

void
game_window_new_turn_start (GameWindow* self,
                            gboolean can_undo)
{
	GSimpleAction* _tmp0_;
	GtkHeaderBar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undo_action;
	g_simple_action_set_enabled (_tmp0_, can_undo);
	_tmp1_ = self->priv->headerbar;
	gtk_header_bar_set_subtitle (_tmp1_, NULL);
}

void
game_window_set_subtitle (GameWindow* self,
                          const gchar* subtitle)
{
	GtkHeaderBar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (subtitle != NULL);
	_tmp0_ = self->priv->headerbar;
	gtk_header_bar_set_subtitle (_tmp0_, subtitle);
}

void
game_window_finish_game (GameWindow* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->game_finished = TRUE;
	_tmp0_ = self->priv->new_game_button;
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
}

static void
game_window_show_new_game_screen (GameWindow* self)
{
	GtkHeaderBar* _tmp0_;
	GtkStack* _tmp1_;
	GtkBox* _tmp2_;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->headerbar;
	gtk_header_bar_set_subtitle (_tmp0_, NULL);
	_tmp1_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp1_, "start-box");
	_tmp2_ = self->priv->controls_box;
	gtk_widget_hide ((GtkWidget*) _tmp2_);
	if (!self->priv->game_finished) {
		GtkButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->back_button;
		_tmp5_ = gtk_widget_get_visible ((GtkWidget*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp3_ = _tmp6_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GtkButton* _tmp7_;
		_tmp7_ = self->priv->back_button;
		gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
	} else {
		GtkButton* _tmp8_;
		_tmp8_ = self->priv->start_game_button;
		if (_tmp8_ != NULL) {
			GtkButton* _tmp9_;
			_tmp9_ = self->priv->start_game_button;
			gtk_widget_grab_focus ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_button_get_type (), GtkButton));
		}
	}
}

static void
game_window_show_view (GameWindow* self)
{
	GtkStack* _tmp0_;
	GtkButton* _tmp1_;
	GtkBox* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp0_, "frame");
	_tmp1_ = self->priv->back_button;
	gtk_widget_hide ((GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->controls_box;
	gtk_widget_show ((GtkWidget*) _tmp2_);
	if (self->priv->game_finished) {
		GtkButton* _tmp3_;
		_tmp3_ = self->priv->new_game_button;
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
	} else {
		GtkWidget* _tmp4_;
		_tmp4_ = self->priv->view;
		gtk_widget_grab_focus (_tmp4_);
	}
}

static void
game_window_new_game_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GtkStack* _tmp6_;
	GtkStack* _tmp7_;
	GtkButton* _tmp8_;
	GSimpleAction* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	stack_child = _tmp2_;
	_tmp4_ = stack_child;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = stack_child;
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "frame") != 0;
	}
	if (_tmp3_) {
		_g_free0 (stack_child);
		return;
	}
	g_signal_emit (self, game_window_signals[GAME_WINDOW_WAIT_SIGNAL], 0);
	_tmp6_ = self->priv->stack;
	gtk_stack_set_transition_type (_tmp6_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT);
	_tmp7_ = self->priv->stack;
	gtk_stack_set_transition_duration (_tmp7_, (guint) 800);
	_tmp8_ = self->priv->back_button;
	gtk_widget_show ((GtkWidget*) _tmp8_);
	_tmp9_ = self->priv->back_action;
	g_simple_action_set_enabled (_tmp9_, TRUE);
	game_window_show_new_game_screen (self);
	_g_free0 (stack_child);
}

static void
game_window_start_game_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GSimpleAction* _tmp6_;
	GtkStack* _tmp7_;
	GtkStack* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	stack_child = _tmp2_;
	_tmp4_ = stack_child;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = stack_child;
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "start-box") != 0;
	}
	if (_tmp3_) {
		_g_free0 (stack_child);
		return;
	}
	self->priv->game_finished = FALSE;
	_tmp6_ = self->priv->undo_action;
	g_simple_action_set_enabled (_tmp6_, FALSE);
	g_signal_emit (self, game_window_signals[GAME_WINDOW_PLAY_SIGNAL], 0);
	_tmp7_ = self->priv->stack;
	gtk_stack_set_transition_type (_tmp7_, GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN);
	_tmp8_ = self->priv->stack;
	gtk_stack_set_transition_duration (_tmp8_, (guint) 1000);
	game_window_show_view (self);
	_g_free0 (stack_child);
}

static void
game_window_back_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	GtkStack* _tmp6_;
	GtkStack* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	stack_child = _tmp2_;
	_tmp4_ = stack_child;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = stack_child;
		_tmp3_ = g_strcmp0 ((const gchar*) _tmp5_, "start-box") != 0;
	}
	if (_tmp3_) {
		_g_free0 (stack_child);
		return;
	}
	_tmp6_ = self->priv->stack;
	gtk_stack_set_transition_type (_tmp6_, GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT);
	_tmp7_ = self->priv->stack;
	gtk_stack_set_transition_duration (_tmp7_, (guint) 800);
	game_window_show_view (self);
	g_signal_emit (self, game_window_signals[GAME_WINDOW_BACK_SIGNAL], 0);
	_g_free0 (stack_child);
}

static void
game_window_undo_cb (GameWindow* self)
{
	gchar* stack_child = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkButton* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	stack_child = _tmp2_;
	_tmp3_ = stack_child;
	if (_tmp3_ == NULL) {
		_g_free0 (stack_child);
		return;
	}
	_tmp4_ = stack_child;
	if (g_strcmp0 ((const gchar*) _tmp4_, "frame") != 0) {
		GSimpleAction* _tmp5_;
		_tmp5_ = self->priv->back_action;
		if (g_action_get_enabled ((GAction*) _tmp5_)) {
			game_window_back_cb (self);
		}
		_g_free0 (stack_child);
		return;
	}
	self->priv->game_finished = FALSE;
	_tmp6_ = self->priv->back_button;
	g_object_get ((GtkWidget*) _tmp6_, "is-focus", &_tmp7_, NULL);
	_tmp8_ = _tmp7_;
	if (!_tmp8_) {
		GtkWidget* _tmp9_;
		_tmp9_ = self->priv->view;
		gtk_widget_grab_focus (_tmp9_);
	}
	g_signal_emit (self, game_window_signals[GAME_WINDOW_UNDO_SIGNAL], 0);
	_g_free0 (stack_child);
}

static void
game_window_toggle_hamburger (GameWindow* self)
{
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->info_button;
	_tmp1_ = self->priv->info_button;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
}

static void
game_window_class_init (GameWindowClass * klass,
                        gpointer klass_data)
{
	game_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GameWindow_private_offset);
	G_OBJECT_CLASS (klass)->finalize = game_window_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Reversi/ui/game-window.ui");
	game_window_signals[GAME_WINDOW_PLAY_SIGNAL] = g_signal_new ("play", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	game_window_signals[GAME_WINDOW_WAIT_SIGNAL] = g_signal_new ("wait", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	game_window_signals[GAME_WINDOW_BACK_SIGNAL] = g_signal_new ("back", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	game_window_signals[GAME_WINDOW_UNDO_SIGNAL] = g_signal_new ("undo", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, headerbar));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_game_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, new_game_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, back_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unfullscreen_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, unfullscreen_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "controls_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, controls_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, game_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_game_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, new_game_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "side_box", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, side_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "info_button", FALSE, GameWindow_private_offset + G_STRUCT_OFFSET (GameWindowPrivate, info_button));
}

static void
game_window_instance_init (GameWindow * self,
                           gpointer klass)
{
	self->priv = game_window_get_instance_private (self);
	self->priv->game_finished = FALSE;
	self->priv->start_game_button = NULL;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
game_window_finalize (GObject * obj)
{
	GameWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_WINDOW, GameWindow);
	_g_object_unref0 (self->priv->headerbar);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->start_game_button);
	_g_object_unref0 (self->priv->new_game_button);
	_g_object_unref0 (self->priv->back_button);
	_g_object_unref0 (self->priv->unfullscreen_button);
	_g_object_unref0 (self->priv->controls_box);
	_g_object_unref0 (self->priv->game_box);
	_g_object_unref0 (self->priv->new_game_box);
	_g_object_unref0 (self->priv->side_box);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->priv->back_action);
	_g_object_unref0 (self->priv->undo_action);
	_g_object_unref0 (self->priv->info_button);
	G_OBJECT_CLASS (game_window_parent_class)->finalize (obj);
}

GType
game_window_get_type (void)
{
	static volatile gsize game_window_type_id__volatile = 0;
	if (g_once_init_enter (&game_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameWindow), 0, (GInstanceInitFunc) game_window_instance_init, NULL };
		GType game_window_type_id;
		game_window_type_id = g_type_register_static (gtk_application_window_get_type (), "GameWindow", &g_define_type_info, 0);
		GameWindow_private_offset = g_type_add_instance_private (game_window_type_id, sizeof (GameWindowPrivate));
		g_once_init_leave (&game_window_type_id__volatile, game_window_type_id);
	}
	return game_window_type_id__volatile;
}

