/* game.c generated by valac 0.44.7, the Vala compiler
 * generated from game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	GAME_0_PROPERTY,
	GAME_SIZE_PROPERTY,
	GAME_CURRENT_COLOR_PROPERTY,
	GAME_NUMBER_OF_MOVES_PROPERTY,
	GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_IS_COMPLETE_PROPERTY,
	GAME_INITIAL_NUMBER_OF_TILES_PROPERTY,
	GAME_N_TILES_PROPERTY,
	GAME_N_LIGHT_TILES_PROPERTY,
	GAME_N_DARK_TILES_PROPERTY,
	GAME_N_CURRENT_TILES_PROPERTY,
	GAME_N_OPPONENT_TILES_PROPERTY,
	GAME_ALTERNATIVE_START_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GAME_TURN_ENDED_SIGNAL,
	GAME_SQUARE_CHANGED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	Player* tiles;
	gint tiles_length1;
	gint tiles_length2;
	guint8 _size;
	guint8** undo_stack;
	gint undo_stack_length1;
	gint _undo_stack_size_;
	gint history_index;
	Player _current_color;
	guint8 _number_of_moves;
	gboolean _current_player_can_move;
	gboolean _is_complete;
	guint8 _initial_number_of_tiles;
	guint8 _n_light_tiles;
	guint8 _n_dark_tiles;
	gboolean _alternative_start;
};

static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
GType player_get_type (void) G_GNUC_CONST;
Game* game_new (gboolean alternative_start,
                guint8 _size);
Game* game_construct (GType object_type,
                      gboolean alternative_start,
                      guint8 _size);
static void game_init_undo_stack (guint8 size,
                           guint8*** undo_stack,
                           gint* undo_stack_length1);
static void game_set_initial_number_of_tiles (Game* self,
                                       guint8 value);
static void game_set_n_current_tiles (Game* self,
                               guint8 value);
static void game_set_n_opponent_tiles (Game* self,
                                guint8 value);
Game* game_new_from_strings (gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size);
Game* game_construct_from_strings (GType object_type,
                                   gchar** setup,
                                   gint setup_length1,
                                   Player to_move,
                                   guint8 _size);
Player player_from_char (gchar c);
static void game_set_current_color (Game* self,
                             Player value);
gchar* game_to_string (Game* self);
guint8 game_get_size (Game* self);
gchar* player_to_string (Player self);
Game* game_new_copy (Game* game);
Game* game_construct_copy (GType object_type,
                           Game* game);
guint8 game_get_number_of_moves (Game* self);
static void game_set_number_of_moves (Game* self,
                               guint8 value);
Player game_get_current_color (Game* self);
guint8 game_get_n_current_tiles (Game* self);
guint8 game_get_n_opponent_tiles (Game* self);
gboolean game_is_valid_location_signed (Game* self,
                                        gint8 x,
                                        gint8 y);
gboolean game_is_valid_location_unsigned (Game* self,
                                          guint8 x,
                                          guint8 y);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
gboolean game_can_place (Game* self,
                         guint8 x,
                         guint8 y,
                         Player color);
static guint8 game_can_flip_tiles (Game* self,
                            guint8 x,
                            guint8 y,
                            gint8 x_step,
                            gint8 y_step,
                            Player color);
guint8 game_place_tile (Game* self,
                        guint8 x,
                        guint8 y,
                        gboolean apply);
static guint8 game_flip_tiles (Game* self,
                        guint8 x,
                        guint8 y,
                        gint8 x_step,
                        gint8 y_step,
                        gboolean apply);
static void game_set_tile (Game* self,
                    guint8 x,
                    guint8 y);
static void game_end_of_turn (Game* self);
void game_pass (Game* self);
gboolean game_get_current_player_can_move (Game* self);
Player player_flip_color (Player p);
static void game_update_who_can_move (Game* self);
static void game_set_current_player_can_move (Game* self,
                                       gboolean value);
static void game_set_is_complete (Game* self,
                           gboolean value);
static guint8* _uint8_dup (guint8* self);
void game_undo (Game* self,
                guint8 count);
static void game_unset_tile (Game* self,
                      guint8 tile_number,
                      Player replacement_color);
static void game_set_size (Game* self,
                    guint8 value);
gboolean game_get_is_complete (Game* self);
guint8 game_get_initial_number_of_tiles (Game* self);
guint8 game_get_n_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
guint8 game_get_n_light_tiles (Game* self);
gboolean game_get_alternative_start (Game* self);
static void game_set_alternative_start (Game* self,
                                 gboolean value);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR_ENUM (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static GObject * game_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gboolean alternative_start,
                guint8 _size)
{
	Game * self = NULL;
	guint8** _tmp5_ = NULL;
	gint _tmp6_ = 0;
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
	self = (Game*) g_object_new (object_type, "alternative-start", alternative_start, "size", _size, NULL);
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < _size)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							Player* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < _size)) {
								break;
							}
							_tmp4_ = self->priv->tiles;
							_tmp4__length1 = self->priv->tiles_length1;
							_tmp4__length2 = self->priv->tiles_length2;
							_tmp4_[(x * _tmp4__length2) + y] = PLAYER_NONE;
						}
					}
				}
			}
		}
	}
	game_init_undo_stack (_size, &_tmp5_, &_tmp6_);
	self->priv->undo_stack = (_vala_array_free (self->priv->undo_stack, self->priv->undo_stack_length1, (GDestroyNotify) g_free), NULL);
	self->priv->undo_stack = _tmp5_;
	self->priv->undo_stack_length1 = _tmp6_;
	self->priv->_undo_stack_size_ = self->priv->undo_stack_length1;
	if ((_size % 2) == 0) {
		Player _tmp7_ = 0;
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player* _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		Player _tmp10_ = 0;
		Player* _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		Player* _tmp12_;
		gint _tmp12__length1;
		gint _tmp12__length2;
		game_set_initial_number_of_tiles (self, (guint8) 4);
		if (alternative_start) {
			_tmp7_ = PLAYER_DARK;
		} else {
			_tmp7_ = PLAYER_LIGHT;
		}
		_tmp8_ = self->priv->tiles;
		_tmp8__length1 = self->priv->tiles_length1;
		_tmp8__length2 = self->priv->tiles_length2;
		_tmp8_[(((_size / 2) - 1) * _tmp8__length2) + ((_size / 2) - 1)] = _tmp7_;
		_tmp9_ = self->priv->tiles;
		_tmp9__length1 = self->priv->tiles_length1;
		_tmp9__length2 = self->priv->tiles_length2;
		_tmp9_[(((_size / 2) - 1) * _tmp9__length2) + (_size / 2)] = PLAYER_DARK;
		if (alternative_start) {
			_tmp10_ = PLAYER_LIGHT;
		} else {
			_tmp10_ = PLAYER_DARK;
		}
		_tmp11_ = self->priv->tiles;
		_tmp11__length1 = self->priv->tiles_length1;
		_tmp11__length2 = self->priv->tiles_length2;
		_tmp11_[((_size / 2) * _tmp11__length2) + ((_size / 2) - 1)] = _tmp10_;
		_tmp12_ = self->priv->tiles;
		_tmp12__length1 = self->priv->tiles_length1;
		_tmp12__length2 = self->priv->tiles_length2;
		_tmp12_[((_size / 2) * _tmp12__length2) + (_size / 2)] = PLAYER_LIGHT;
		game_set_n_current_tiles (self, (guint8) 2);
		game_set_n_opponent_tiles (self, (guint8) 2);
	} else {
		Player* _tmp13_;
		gint _tmp13__length1;
		gint _tmp13__length2;
		Player _tmp14_ = 0;
		Player* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		Player _tmp16_ = 0;
		Player* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		Player* _tmp18_;
		gint _tmp18__length1;
		gint _tmp18__length2;
		Player _tmp19_ = 0;
		Player* _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		Player _tmp21_ = 0;
		Player* _tmp22_;
		gint _tmp22__length1;
		gint _tmp22__length2;
		Player* _tmp23_;
		gint _tmp23__length1;
		gint _tmp23__length2;
		game_set_initial_number_of_tiles (self, (guint8) 7);
		_tmp13_ = self->priv->tiles;
		_tmp13__length1 = self->priv->tiles_length1;
		_tmp13__length2 = self->priv->tiles_length2;
		_tmp13_[(((_size - 1) / 2) * _tmp13__length2) + ((_size - 1) / 2)] = PLAYER_DARK;
		if (alternative_start) {
			_tmp14_ = PLAYER_LIGHT;
		} else {
			_tmp14_ = PLAYER_DARK;
		}
		_tmp15_ = self->priv->tiles;
		_tmp15__length1 = self->priv->tiles_length1;
		_tmp15__length2 = self->priv->tiles_length2;
		_tmp15_[(((_size + 1) / 2) * _tmp15__length2) + ((_size - 3) / 2)] = _tmp14_;
		if (alternative_start) {
			_tmp16_ = PLAYER_LIGHT;
		} else {
			_tmp16_ = PLAYER_DARK;
		}
		_tmp17_ = self->priv->tiles;
		_tmp17__length1 = self->priv->tiles_length1;
		_tmp17__length2 = self->priv->tiles_length2;
		_tmp17_[(((_size - 3) / 2) * _tmp17__length2) + ((_size + 1) / 2)] = _tmp16_;
		_tmp18_ = self->priv->tiles;
		_tmp18__length1 = self->priv->tiles_length1;
		_tmp18__length2 = self->priv->tiles_length2;
		_tmp18_[(((_size - 1) / 2) * _tmp18__length2) + ((_size - 3) / 2)] = PLAYER_LIGHT;
		if (alternative_start) {
			_tmp19_ = PLAYER_DARK;
		} else {
			_tmp19_ = PLAYER_LIGHT;
		}
		_tmp20_ = self->priv->tiles;
		_tmp20__length1 = self->priv->tiles_length1;
		_tmp20__length2 = self->priv->tiles_length2;
		_tmp20_[(((_size - 3) / 2) * _tmp20__length2) + ((_size - 1) / 2)] = _tmp19_;
		if (alternative_start) {
			_tmp21_ = PLAYER_DARK;
		} else {
			_tmp21_ = PLAYER_LIGHT;
		}
		_tmp22_ = self->priv->tiles;
		_tmp22__length1 = self->priv->tiles_length1;
		_tmp22__length2 = self->priv->tiles_length2;
		_tmp22_[(((_size + 1) / 2) * _tmp22__length2) + ((_size - 1) / 2)] = _tmp21_;
		_tmp23_ = self->priv->tiles;
		_tmp23__length1 = self->priv->tiles_length1;
		_tmp23__length2 = self->priv->tiles_length2;
		_tmp23_[(((_size - 1) / 2) * _tmp23__length2) + ((_size + 1) / 2)] = PLAYER_LIGHT;
		game_set_n_current_tiles (self, (guint8) 3);
		game_set_n_opponent_tiles (self, (guint8) 4);
	}
	return self;
}

Game*
game_new (gboolean alternative_start,
          guint8 _size)
{
	return game_construct (TYPE_GAME, alternative_start, _size);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len = len + _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len = len + (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp19_ = res;
		_tmp20_ = str_array[0];
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
		ptr = _tmp21_;
		{
			gboolean _tmp22_ = FALSE;
			i = 1;
			_tmp22_ = TRUE;
			while (TRUE) {
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp24_ = ptr;
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
				ptr = _tmp25_;
				_tmp27_ = str_array[i];
				if (_tmp27_ != NULL) {
					const gchar* _tmp28_;
					_tmp28_ = str_array[i];
					_tmp26_ = (const gchar*) _tmp28_;
				} else {
					_tmp26_ = "";
				}
				_tmp29_ = ptr;
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
				ptr = _tmp30_;
			}
		}
		_tmp31_ = res;
		res = NULL;
		result = (gchar*) _tmp31_;
		return result;
	} else {
		gchar* _tmp32_;
		_tmp32_ = g_strdup ("");
		result = _tmp32_;
		return result;
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}

Game*
game_construct_from_strings (GType object_type,
                             gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size)
{
	Game * self = NULL;
	guint8** _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
	_vala_return_val_if_fail (to_move != PLAYER_NONE, "to_move != Player.NONE", NULL);
	_vala_return_val_if_fail (setup_length1 == ((gint) _size), "setup.length == _size", NULL);
	self = (Game*) g_object_new (object_type, "size", _size, NULL);
	game_init_undo_stack (_size, &_tmp0_, &_tmp1_);
	self->priv->undo_stack = (_vala_array_free (self->priv->undo_stack, self->priv->undo_stack_length1, (GDestroyNotify) g_free), NULL);
	self->priv->undo_stack = _tmp0_;
	self->priv->undo_stack_length1 = _tmp1_;
	self->priv->_undo_stack_size_ = self->priv->undo_stack_length1;
	{
		guint8 y = 0U;
		y = (guint8) 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				const gchar* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				if (!_tmp2_) {
					guint8 _tmp3_;
					_tmp3_ = y;
					y = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(y < _size)) {
					break;
				}
				_tmp4_ = setup[y];
				_tmp5_ = strlen (_tmp4_);
				_tmp6_ = _tmp5_;
				if (_tmp6_ != (_size * 2)) {
					g_warn_if_reached ();
				}
				{
					guint8 x = 0U;
					x = (guint8) 0;
					{
						gboolean _tmp7_ = FALSE;
						_tmp7_ = TRUE;
						while (TRUE) {
							Player* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							const gchar* _tmp10_;
							if (!_tmp7_) {
								guint8 _tmp8_;
								_tmp8_ = x;
								x = _tmp8_ + 1;
							}
							_tmp7_ = FALSE;
							if (!(x < _size)) {
								break;
							}
							_tmp9_ = self->priv->tiles;
							_tmp9__length1 = self->priv->tiles_length1;
							_tmp9__length2 = self->priv->tiles_length2;
							_tmp10_ = setup[y];
							_tmp9_[(x * _tmp9__length2) + y] = player_from_char (string_get (_tmp10_, (glong) ((x * 2) + 1)));
						}
					}
				}
			}
		}
	}
	game_set_current_color (self, to_move);
	_tmp11_ = _vala_g_strjoinv ("\n", (gchar**) setup, (gint) ((setup_length1 * sizeof (gchar*)) / sizeof (gchar*)));
	_tmp12_ = _tmp11_;
	_tmp13_ = string_strip (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = game_to_string (self);
	_tmp16_ = _tmp15_;
	_tmp17_ = string_strip (_tmp16_);
	_tmp18_ = _tmp17_;
	g_warn_if_fail (g_strcmp0 (_tmp14_, _tmp18_) == 0);
	_g_free0 (_tmp18_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	return self;
}

Game*
game_new_from_strings (gchar** setup,
                       gint setup_length1,
                       Player to_move,
                       guint8 _size)
{
	return game_construct_from_strings (TYPE_GAME, setup, setup_length1, to_move, _size);
}

gchar*
game_to_string (Game* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("\n");
	s = _tmp0_;
	{
		guint8 y = 0U;
		y = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				guint8 _tmp3_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = y;
					y = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = self->priv->_size;
				if (!(y < _tmp3_)) {
					break;
				}
				{
					guint8 x = 0U;
					x = (guint8) 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint8 _tmp6_;
							const gchar* _tmp7_;
							Player* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							Player _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
							gchar* _tmp13_;
							gchar* _tmp14_;
							if (!_tmp4_) {
								guint8 _tmp5_;
								_tmp5_ = x;
								x = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = self->priv->_size;
							if (!(x < _tmp6_)) {
								break;
							}
							_tmp7_ = s;
							_tmp8_ = self->priv->tiles;
							_tmp8__length1 = self->priv->tiles_length1;
							_tmp8__length2 = self->priv->tiles_length2;
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
							_tmp10_ = player_to_string (_tmp9_);
							_tmp11_ = _tmp10_;
							_tmp12_ = g_strconcat (" ", _tmp11_, NULL);
							_tmp13_ = _tmp12_;
							_tmp14_ = g_strconcat (_tmp7_, _tmp13_, NULL);
							_g_free0 (s);
							s = _tmp14_;
							_g_free0 (_tmp13_);
							_g_free0 (_tmp11_);
						}
					}
				}
				_tmp15_ = s;
				_tmp16_ = g_strconcat (_tmp15_, "\n", NULL);
				_g_free0 (s);
				s = _tmp16_;
			}
		}
	}
	result = s;
	return result;
}

Game*
game_construct_copy (GType object_type,
                     Game* game)
{
	Game * self = NULL;
	guint8 _tmp0_;
	guint8 _tmp10_;
	Player _tmp11_;
	guint8 _tmp12_;
	guint8 _tmp13_;
	guint8 _tmp14_;
	guint8 _tmp15_;
	guint8** _tmp16_ = NULL;
	gint _tmp17_ = 0;
	g_return_val_if_fail (game != NULL, NULL);
	_tmp0_ = game->priv->_size;
	self = (Game*) g_object_new (object_type, "size", _tmp0_, NULL);
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				guint8 _tmp3_;
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = self->priv->_size;
				if (!(x < _tmp3_)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint8 _tmp6_;
							Player* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							Player* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							Player _tmp9_;
							if (!_tmp4_) {
								guint8 _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = self->priv->_size;
							if (!(y < _tmp6_)) {
								break;
							}
							_tmp7_ = self->priv->tiles;
							_tmp7__length1 = self->priv->tiles_length1;
							_tmp7__length2 = self->priv->tiles_length2;
							_tmp8_ = game->priv->tiles;
							_tmp8__length1 = game->priv->tiles_length1;
							_tmp8__length2 = game->priv->tiles_length2;
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
							_tmp7_[(x * _tmp7__length2) + y] = _tmp9_;
						}
					}
				}
			}
		}
	}
	_tmp10_ = game->priv->_number_of_moves;
	game_set_number_of_moves (self, _tmp10_);
	_tmp11_ = game->priv->_current_color;
	game_set_current_color (self, _tmp11_);
	_tmp12_ = game_get_n_current_tiles (game);
	_tmp13_ = _tmp12_;
	game_set_n_current_tiles (self, _tmp13_);
	_tmp14_ = game_get_n_opponent_tiles (game);
	_tmp15_ = _tmp14_;
	game_set_n_opponent_tiles (self, _tmp15_);
	game_init_undo_stack (self->priv->_size, &_tmp16_, &_tmp17_);
	self->priv->undo_stack = (_vala_array_free (self->priv->undo_stack, self->priv->undo_stack_length1, (GDestroyNotify) g_free), NULL);
	self->priv->undo_stack = _tmp16_;
	self->priv->undo_stack_length1 = _tmp17_;
	self->priv->_undo_stack_size_ = self->priv->undo_stack_length1;
	return self;
}

Game*
game_new_copy (Game* game)
{
	return game_construct_copy (TYPE_GAME, game);
}

inline gboolean
game_is_valid_location_signed (Game* self,
                               gint8 x,
                               gint8 y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (((gint) x) >= 0) {
		guint8 _tmp3_;
		_tmp3_ = self->priv->_size;
		_tmp2_ = ((guint8) x) < _tmp3_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = ((gint) y) >= 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		guint8 _tmp4_;
		_tmp4_ = self->priv->_size;
		_tmp0_ = ((guint8) y) < _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

inline gboolean
game_is_valid_location_unsigned (Game* self,
                                 guint8 x,
                                 guint8 y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint8 _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->_size;
	if (x < _tmp1_) {
		guint8 _tmp2_;
		_tmp2_ = self->priv->_size;
		_tmp0_ = y < _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

Player
game_get_owner (Game* self,
                guint8 x,
                guint8 y)
{
	Player result = 0;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_vala_return_val_if_fail (game_is_valid_location_unsigned (self, x, y), "is_valid_location_unsigned (x, y)", 0);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	result = _tmp1_;
	return result;
}

gboolean
game_can_place (Game* self,
                guint8 x,
                guint8 y,
                Player color)
{
	gboolean result = FALSE;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_return_val_if_fail (game_is_valid_location_unsigned (self, x, y), "is_valid_location_unsigned (x, y)", FALSE);
	_vala_return_val_if_fail (color != PLAYER_NONE, "color != Player.NONE", FALSE);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	if (_tmp1_ != PLAYER_NONE) {
		result = FALSE;
		return result;
	}
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 1, (gint8) 0, color)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 1, (gint8) 1, color)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 0, (gint8) 1, color)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) -1, (gint8) 1, color)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) -1, (gint8) 0, color)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) -1, (gint8) -1, color)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 0, (gint8) -1, color)) > 0) {
		result = TRUE;
		return result;
	}
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 1, (gint8) -1, color)) > 0) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

guint8
game_place_tile (Game* self,
                 guint8 x,
                 guint8 y,
                 gboolean apply)
{
	guint8 result = 0U;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	guint8 tiles_turned = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_vala_return_val_if_fail (game_is_valid_location_unsigned (self, x, y), "is_valid_location_unsigned (x, y)", 0U);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	if (_tmp1_ != PLAYER_NONE) {
		result = (guint8) 0;
		return result;
	}
	tiles_turned = (guint8) 0;
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 1, (gint8) 0, apply);
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 1, (gint8) 1, apply);
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 0, (gint8) 1, apply);
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) -1, (gint8) 1, apply);
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) -1, (gint8) 0, apply);
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) -1, (gint8) -1, apply);
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 0, (gint8) -1, apply);
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 1, (gint8) -1, apply);
	if (((gint) tiles_turned) == 0) {
		result = (guint8) 0;
		return result;
	}
	if (apply) {
		game_set_tile (self, x, y);
		game_end_of_turn (self);
	}
	result = tiles_turned;
	return result;
}

void
game_pass (Game* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_player_can_move;
	_vala_return_if_fail (!_tmp0_, "!current_player_can_move");
	game_end_of_turn (self);
}

static void
game_end_of_turn (Game* self)
{
	guint8** _tmp0_;
	gint _tmp0__length1;
	Player _tmp1_;
	guint8 _tmp2_;
	gint _tmp3_;
	guint8** _tmp4_;
	gint _tmp4__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undo_stack;
	_tmp0__length1 = self->priv->undo_stack_length1;
	_vala_return_if_fail ((self->priv->history_index >= -1) && (self->priv->history_index < (_tmp0__length1 - 2)), "history_index >= -1 && history_index < undo_stack.length - 2");
	_tmp1_ = self->priv->_current_color;
	game_set_current_color (self, player_flip_color (_tmp1_));
	_tmp2_ = self->priv->_number_of_moves;
	game_set_number_of_moves (self, _tmp2_ + 1);
	_tmp3_ = self->priv->history_index;
	self->priv->history_index = _tmp3_ + 1;
	_tmp4_ = self->priv->undo_stack;
	_tmp4__length1 = self->priv->undo_stack_length1;
	_g_free0 (_tmp4_[self->priv->history_index]);
	_tmp4_[self->priv->history_index] = NULL;
	game_update_who_can_move (self);
	g_signal_emit (self, game_signals[GAME_TURN_ENDED_SIGNAL], 0);
}

static void
game_update_who_can_move (Game* self)
{
	Player enemy = 0;
	Player _tmp0_;
	gboolean opponent_can_move = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_color;
	enemy = player_flip_color (_tmp0_);
	opponent_can_move = FALSE;
	{
		guint8 x = 0U;
		x = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				guint8 _tmp3_;
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = self->priv->_size;
				if (!(x < _tmp3_)) {
					break;
				}
				{
					guint8 y = 0U;
					y = (guint8) 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint8 _tmp6_;
							Player _tmp7_;
							Player _tmp8_;
							if (!_tmp4_) {
								guint8 _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = self->priv->_size;
							if (!(y < _tmp6_)) {
								break;
							}
							_tmp7_ = self->priv->_current_color;
							if (game_can_place (self, x, y, _tmp7_)) {
								game_set_current_player_can_move (self, TRUE);
								return;
							}
							_tmp8_ = enemy;
							if (game_can_place (self, x, y, _tmp8_)) {
								opponent_can_move = TRUE;
							}
						}
					}
				}
			}
		}
	}
	game_set_current_player_can_move (self, FALSE);
	if (!opponent_can_move) {
		game_set_is_complete (self, TRUE);
	}
}

static guint8
game_flip_tiles (Game* self,
                 guint8 x,
                 guint8 y,
                 gint8 x_step,
                 gint8 y_step,
                 gboolean apply)
{
	guint8 result = 0U;
	guint8 enemy_count = 0U;
	Player _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_current_color;
	enemy_count = game_can_flip_tiles (self, x, y, x_step, y_step, _tmp0_);
	if (((gint) enemy_count) == 0) {
		result = (guint8) 0;
		return result;
	}
	if (apply) {
		{
			gint8 i = 0;
			i = (gint8) 1;
			{
				gboolean _tmp1_ = FALSE;
				_tmp1_ = TRUE;
				while (TRUE) {
					guint8 _tmp3_;
					guint8 _tmp4_;
					if (!_tmp1_) {
						gint8 _tmp2_;
						_tmp2_ = i;
						i = _tmp2_ + 1;
					}
					_tmp1_ = FALSE;
					if (!(((guint8) i) <= enemy_count)) {
						break;
					}
					_tmp3_ = game_get_n_opponent_tiles (self);
					_tmp4_ = _tmp3_;
					game_set_n_opponent_tiles (self, _tmp4_ - 1);
					game_set_tile (self, x + ((guint8) (i * x_step)), y + ((guint8) (i * y_step)));
				}
			}
		}
	}
	result = enemy_count;
	return result;
}

static guint8
game_can_flip_tiles (Game* self,
                     guint8 x,
                     guint8 y,
                     gint8 x_step,
                     gint8 y_step,
                     Player color)
{
	guint8 result = 0U;
	Player enemy = 0;
	gint8 enemy_count = 0;
	gint8 xt = 0;
	gint8 yt = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	g_return_val_if_fail (self != NULL, 0U);
	enemy = player_flip_color (color);
	enemy_count = (gint8) -1;
	xt = (gint8) x;
	yt = (gint8) y;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gint8 _tmp5_;
			if (!_tmp0_) {
				gboolean _tmp1_ = FALSE;
				if (game_is_valid_location_signed (self, xt, yt)) {
					Player* _tmp2_;
					gint _tmp2__length1;
					gint _tmp2__length2;
					Player _tmp3_;
					Player _tmp4_;
					_tmp2_ = self->priv->tiles;
					_tmp2__length1 = self->priv->tiles_length1;
					_tmp2__length2 = self->priv->tiles_length2;
					_tmp3_ = _tmp2_[(xt * _tmp2__length2) + yt];
					_tmp4_ = enemy;
					_tmp1_ = _tmp3_ == _tmp4_;
				} else {
					_tmp1_ = FALSE;
				}
				if (!_tmp1_) {
					break;
				}
			}
			_tmp0_ = FALSE;
			_tmp5_ = enemy_count;
			enemy_count = _tmp5_ + 1;
			xt = xt + x_step;
			yt = yt + y_step;
		}
	}
	if (((gint) enemy_count) == 0) {
		_tmp7_ = TRUE;
	} else {
		_tmp7_ = !game_is_valid_location_signed (self, xt, yt);
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player _tmp9_;
		_tmp8_ = self->priv->tiles;
		_tmp8__length1 = self->priv->tiles_length1;
		_tmp8__length2 = self->priv->tiles_length2;
		_tmp9_ = _tmp8_[(xt * _tmp8__length2) + yt];
		_tmp6_ = _tmp9_ != color;
	}
	if (_tmp6_) {
		result = (guint8) 0;
		return result;
	}
	result = (guint8) enemy_count;
	return result;
}

static guint8*
_uint8_dup (guint8* self)
{
	guint8* dup;
	dup = g_new0 (guint8, 1);
	memcpy (dup, self, sizeof (guint8));
	return dup;
}

static gpointer
__uint8_dup0 (gpointer self)
{
	return self ? _uint8_dup (self) : NULL;
}

static void
game_set_tile (Game* self,
               guint8 x,
               guint8 y)
{
	guint8** _tmp0_;
	gint _tmp0__length1;
	guint8 _tmp1_;
	guint8 _tmp2_;
	gint _tmp3_;
	guint8** _tmp4_;
	gint _tmp4__length1;
	guint8 _tmp5_;
	guint8 _tmp6_;
	guint8* _tmp7_;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	Player _tmp9_;
	Player _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undo_stack;
	_tmp0__length1 = self->priv->undo_stack_length1;
	_vala_return_if_fail ((self->priv->history_index >= -1) && (self->priv->history_index < (_tmp0__length1 - 2)), "history_index >= -1 && history_index < undo_stack.length - 2");
	_tmp1_ = game_get_n_current_tiles (self);
	_tmp2_ = _tmp1_;
	game_set_n_current_tiles (self, _tmp2_ + 1);
	_tmp3_ = self->priv->history_index;
	self->priv->history_index = _tmp3_ + 1;
	_tmp4_ = self->priv->undo_stack;
	_tmp4__length1 = self->priv->undo_stack_length1;
	_tmp5_ = self->priv->_size;
	_tmp6_ = x + (y * _tmp5_);
	_tmp7_ = __uint8_dup0 (&_tmp6_);
	_g_free0 (_tmp4_[self->priv->history_index]);
	_tmp4_[self->priv->history_index] = _tmp7_;
	_tmp8_ = self->priv->tiles;
	_tmp8__length1 = self->priv->tiles_length1;
	_tmp8__length2 = self->priv->tiles_length2;
	_tmp9_ = self->priv->_current_color;
	_tmp8_[(x * _tmp8__length2) + y] = _tmp9_;
	_tmp10_ = self->priv->_current_color;
	g_signal_emit (self, game_signals[GAME_SQUARE_CHANGED_SIGNAL], 0, x, y, _tmp10_);
}

void
game_undo (Game* self,
           guint8 count)
{
	guint8 _tmp0_;
	guint8** _tmp1_;
	gint _tmp1__length1;
	Player enemy = 0;
	Player _tmp2_;
	Player _tmp3_;
	guint8 _tmp4_;
	gint _tmp5_;
	guint8* undo_item = NULL;
	guint8** _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	guint8* _tmp8_;
	guint8* _tmp9_;
	g_return_if_fail (self != NULL);
	_vala_return_if_fail ((((gint) count) == 1) || (((gint) count) == 2), "count == 1 || count == 2");
	_tmp0_ = self->priv->_number_of_moves;
	_vala_return_if_fail (_tmp0_ >= count, "number_of_moves >= count");
	_tmp1_ = self->priv->undo_stack;
	_tmp1__length1 = self->priv->undo_stack_length1;
	_vala_return_if_fail (self->priv->history_index < _tmp1__length1, "history_index < undo_stack.length");
	_tmp2_ = self->priv->_current_color;
	enemy = _tmp2_;
	_tmp3_ = self->priv->_current_color;
	game_set_current_color (self, player_flip_color (_tmp3_));
	_tmp4_ = self->priv->_number_of_moves;
	game_set_number_of_moves (self, _tmp4_ - 1);
	_tmp5_ = self->priv->history_index;
	self->priv->history_index = _tmp5_ - 1;
	_tmp6_ = self->priv->undo_stack;
	_tmp6__length1 = self->priv->undo_stack_length1;
	_tmp7_ = _tmp6_[self->priv->history_index];
	_tmp8_ = __uint8_dup0 (_tmp7_);
	undo_item = _tmp8_;
	_tmp9_ = undo_item;
	if (_tmp9_ != NULL) {
		guint8* _tmp10_;
		guint8** _tmp11_;
		gint _tmp11__length1;
		guint8* _tmp12_;
		guint8* _tmp13_;
		_tmp10_ = undo_item;
		game_unset_tile (self, (guint8) (*_tmp10_), PLAYER_NONE);
		_tmp11_ = self->priv->undo_stack;
		_tmp11__length1 = self->priv->undo_stack_length1;
		_tmp12_ = _tmp11_[self->priv->history_index];
		_tmp13_ = __uint8_dup0 (_tmp12_);
		_g_free0 (undo_item);
		undo_item = _tmp13_;
		while (TRUE) {
			gboolean _tmp14_ = FALSE;
			guint8 _tmp16_;
			guint8 _tmp17_;
			guint8* _tmp18_;
			Player _tmp19_;
			if (self->priv->history_index > -1) {
				guint8* _tmp15_;
				_tmp15_ = undo_item;
				_tmp14_ = _tmp15_ != NULL;
			} else {
				_tmp14_ = FALSE;
			}
			if (!_tmp14_) {
				break;
			}
			_tmp16_ = game_get_n_opponent_tiles (self);
			_tmp17_ = _tmp16_;
			game_set_n_opponent_tiles (self, _tmp17_ + 1);
			_tmp18_ = undo_item;
			_tmp19_ = enemy;
			game_unset_tile (self, (guint8) (*_tmp18_), _tmp19_);
			if (self->priv->history_index > -1) {
				guint8** _tmp20_;
				gint _tmp20__length1;
				guint8* _tmp21_;
				guint8* _tmp22_;
				_tmp20_ = self->priv->undo_stack;
				_tmp20__length1 = self->priv->undo_stack_length1;
				_tmp21_ = _tmp20_[self->priv->history_index];
				_tmp22_ = __uint8_dup0 (_tmp21_);
				_g_free0 (undo_item);
				undo_item = _tmp22_;
			} else {
				_g_free0 (undo_item);
				undo_item = NULL;
			}
		}
	}
	if (((gint) count) == 1) {
		game_set_is_complete (self, FALSE);
		game_update_who_can_move (self);
	} else {
		game_undo (self, (guint8) (count - 1));
	}
	_g_free0 (undo_item);
}

static void
game_unset_tile (Game* self,
                 guint8 tile_number,
                 Player replacement_color)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint _tmp2_;
	guint8 x = 0U;
	guint8 _tmp3_;
	guint8 y = 0U;
	guint8 _tmp4_;
	Player* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = game_get_n_current_tiles (self);
	_tmp1_ = _tmp0_;
	game_set_n_current_tiles (self, _tmp1_ - 1);
	_tmp2_ = self->priv->history_index;
	self->priv->history_index = _tmp2_ - 1;
	_tmp3_ = self->priv->_size;
	x = tile_number % _tmp3_;
	_tmp4_ = self->priv->_size;
	y = tile_number / _tmp4_;
	_tmp5_ = self->priv->tiles;
	_tmp5__length1 = self->priv->tiles_length1;
	_tmp5__length2 = self->priv->tiles_length2;
	_tmp5_[(x * _tmp5__length2) + y] = replacement_color;
	g_signal_emit (self, game_signals[GAME_SQUARE_CHANGED_SIGNAL], 0, x, y, replacement_color);
}

static void
game_init_undo_stack (guint8 size,
                      guint8*** undo_stack,
                      gint* undo_stack_length1)
{
	guint8** _vala_undo_stack = NULL;
	gint _vala_undo_stack_length1 = 0;
	guint8** _tmp0_;
	_tmp0_ = g_new0 (guint8*, ((size * size) - 4) * (3 + ((size - 2) * 4)));
	_vala_undo_stack = (_vala_array_free (_vala_undo_stack, _vala_undo_stack_length1, (GDestroyNotify) g_free), NULL);
	_vala_undo_stack = _tmp0_;
	_vala_undo_stack_length1 = ((size * size) - 4) * (3 + ((size - 2) * 4));
	if (undo_stack) {
		*undo_stack = _vala_undo_stack;
	} else {
		_vala_undo_stack = (_vala_array_free (_vala_undo_stack, _vala_undo_stack_length1, (GDestroyNotify) g_free), NULL);
	}
	if (undo_stack_length1) {
		*undo_stack_length1 = _vala_undo_stack_length1;
	}
}

guint8
game_get_size (Game* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_size;
	return result;
}

static void
game_set_size (Game* self,
               guint8 value)
{
	g_return_if_fail (self != NULL);
	self->priv->_size = value;
}

Player
game_get_current_color (Game* self)
{
	Player result;
	Player _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_current_color;
	result = _tmp0_;
	return result;
}

static void
game_set_current_color (Game* self,
                        Player value)
{
	g_return_if_fail (self != NULL);
	self->priv->_current_color = value;
}

guint8
game_get_number_of_moves (Game* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_number_of_moves;
	return result;
}

static void
game_set_number_of_moves (Game* self,
                          guint8 value)
{
	g_return_if_fail (self != NULL);
	self->priv->_number_of_moves = value;
}

gboolean
game_get_current_player_can_move (Game* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_current_player_can_move;
	return result;
}

static void
game_set_current_player_can_move (Game* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_current_player_can_move = value;
}

gboolean
game_get_is_complete (Game* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_complete;
	return result;
}

static void
game_set_is_complete (Game* self,
                      gboolean value)
{
	g_return_if_fail (self != NULL);
	if (game_get_is_complete (self) != value) {
		self->priv->_is_complete = value;
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_IS_COMPLETE_PROPERTY]);
	}
}

guint8
game_get_initial_number_of_tiles (Game* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_initial_number_of_tiles;
	return result;
}

static void
game_set_initial_number_of_tiles (Game* self,
                                  guint8 value)
{
	g_return_if_fail (self != NULL);
	self->priv->_initial_number_of_tiles = value;
}

guint8
game_get_n_tiles (Game* self)
{
	guint8 result;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = game_get_n_dark_tiles (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = game_get_n_light_tiles (self);
	_tmp3_ = _tmp2_;
	result = _tmp1_ + _tmp3_;
	return result;
}

guint8
game_get_n_light_tiles (Game* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_n_light_tiles;
	return result;
}

guint8
game_get_n_dark_tiles (Game* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_n_dark_tiles;
	return result;
}

guint8
game_get_n_current_tiles (Game* self)
{
	guint8 result;
	guint8 _tmp0_ = 0U;
	Player _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp1_ = self->priv->_current_color;
	if (_tmp1_ == PLAYER_LIGHT) {
		guint8 _tmp2_;
		guint8 _tmp3_;
		_tmp2_ = game_get_n_light_tiles (self);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_;
	} else {
		guint8 _tmp4_;
		guint8 _tmp5_;
		_tmp4_ = game_get_n_dark_tiles (self);
		_tmp5_ = _tmp4_;
		_tmp0_ = _tmp5_;
	}
	result = _tmp0_;
	return result;
}

static void
game_set_n_current_tiles (Game* self,
                          guint8 value)
{
	Player _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_color;
	if (_tmp0_ == PLAYER_LIGHT) {
		self->priv->_n_light_tiles = value;
	} else {
		self->priv->_n_dark_tiles = value;
	}
}

guint8
game_get_n_opponent_tiles (Game* self)
{
	guint8 result;
	guint8 _tmp0_ = 0U;
	Player _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp1_ = self->priv->_current_color;
	if (_tmp1_ == PLAYER_DARK) {
		guint8 _tmp2_;
		guint8 _tmp3_;
		_tmp2_ = game_get_n_light_tiles (self);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_;
	} else {
		guint8 _tmp4_;
		guint8 _tmp5_;
		_tmp4_ = game_get_n_dark_tiles (self);
		_tmp5_ = _tmp4_;
		_tmp0_ = _tmp5_;
	}
	result = _tmp0_;
	return result;
}

static void
game_set_n_opponent_tiles (Game* self,
                           guint8 value)
{
	Player _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_color;
	if (_tmp0_ == PLAYER_DARK) {
		self->priv->_n_light_tiles = value;
	} else {
		self->priv->_n_dark_tiles = value;
	}
}

gboolean
game_get_alternative_start (Game* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_alternative_start;
	return result;
}

static void
game_set_alternative_start (Game* self,
                            gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_alternative_start = value;
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR_ENUM) (gpointer data1, guint8 arg_1, guint8 arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), g_value_get_enum (param_values + 3), data2);
}

static GObject *
game_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Game * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	Player* _tmp2_;
	parent_class = G_OBJECT_CLASS (game_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
	_tmp0_ = self->priv->_size;
	_tmp1_ = self->priv->_size;
	_tmp2_ = g_new0 (Player, _tmp0_ * _tmp1_);
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
	self->priv->tiles = _tmp2_;
	self->priv->tiles_length1 = _tmp0_;
	self->priv->tiles_length2 = _tmp1_;
	return obj;
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
	game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
	G_OBJECT_CLASS (klass)->constructor = game_constructor;
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SIZE_PROPERTY, game_properties[GAME_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, (guint8) 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_COLOR_PROPERTY, game_properties[GAME_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, PLAYER_DARK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_NUMBER_OF_MOVES_PROPERTY, game_properties[GAME_NUMBER_OF_MOVES_PROPERTY] = g_param_spec_uchar ("number-of-moves", "number-of-moves", "number-of-moves", 0, G_MAXUINT8, (guint8) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_properties[GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_IS_COMPLETE_PROPERTY, game_properties[GAME_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_INITIAL_NUMBER_OF_TILES_PROPERTY, game_properties[GAME_INITIAL_NUMBER_OF_TILES_PROPERTY] = g_param_spec_uchar ("initial-number-of-tiles", "initial-number-of-tiles", "initial-number-of-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_TILES_PROPERTY, game_properties[GAME_N_TILES_PROPERTY] = g_param_spec_uchar ("n-tiles", "n-tiles", "n-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_LIGHT_TILES_PROPERTY, game_properties[GAME_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_DARK_TILES_PROPERTY, game_properties[GAME_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_CURRENT_TILES_PROPERTY, game_properties[GAME_N_CURRENT_TILES_PROPERTY] = g_param_spec_uchar ("n-current-tiles", "n-current-tiles", "n-current-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_OPPONENT_TILES_PROPERTY, game_properties[GAME_N_OPPONENT_TILES_PROPERTY] = g_param_spec_uchar ("n-opponent-tiles", "n-opponent-tiles", "n-opponent-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ALTERNATIVE_START_PROPERTY, game_properties[GAME_ALTERNATIVE_START_PROPERTY] = g_param_spec_boolean ("alternative-start", "alternative-start", "alternative-start", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
	game_signals[GAME_TURN_ENDED_SIGNAL] = g_signal_new ("turn-ended", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	game_signals[GAME_SQUARE_CHANGED_SIGNAL] = g_signal_new ("square-changed", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR_ENUM, G_TYPE_NONE, 3, G_TYPE_UCHAR, G_TYPE_UCHAR, TYPE_PLAYER);
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	self->priv = game_get_instance_private (self);
	self->priv->_size = (guint8) 8;
	self->priv->history_index = -1;
	self->priv->_current_color = PLAYER_DARK;
	self->priv->_number_of_moves = (guint8) 0;
	self->priv->_current_player_can_move = TRUE;
	self->priv->_is_complete = FALSE;
	self->priv->_n_light_tiles = (guint8) 2;
	self->priv->_n_dark_tiles = (guint8) 2;
}

static void
game_finalize (GObject * obj)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
	self->priv->undo_stack = (_vala_array_free (self->priv->undo_stack, self->priv->undo_stack_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_SIZE_PROPERTY:
		g_value_set_uchar (value, game_get_size (self));
		break;
		case GAME_CURRENT_COLOR_PROPERTY:
		g_value_set_enum (value, game_get_current_color (self));
		break;
		case GAME_NUMBER_OF_MOVES_PROPERTY:
		g_value_set_uchar (value, game_get_number_of_moves (self));
		break;
		case GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
		g_value_set_boolean (value, game_get_current_player_can_move (self));
		break;
		case GAME_IS_COMPLETE_PROPERTY:
		g_value_set_boolean (value, game_get_is_complete (self));
		break;
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_initial_number_of_tiles (self));
		break;
		case GAME_N_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_n_tiles (self));
		break;
		case GAME_N_LIGHT_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_n_light_tiles (self));
		break;
		case GAME_N_DARK_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_n_dark_tiles (self));
		break;
		case GAME_N_CURRENT_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_n_current_tiles (self));
		break;
		case GAME_N_OPPONENT_TILES_PROPERTY:
		g_value_set_uchar (value, game_get_n_opponent_tiles (self));
		break;
		case GAME_ALTERNATIVE_START_PROPERTY:
		g_value_set_boolean (value, game_get_alternative_start (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_SIZE_PROPERTY:
		game_set_size (self, g_value_get_uchar (value));
		break;
		case GAME_CURRENT_COLOR_PROPERTY:
		game_set_current_color (self, g_value_get_enum (value));
		break;
		case GAME_NUMBER_OF_MOVES_PROPERTY:
		game_set_number_of_moves (self, g_value_get_uchar (value));
		break;
		case GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
		game_set_current_player_can_move (self, g_value_get_boolean (value));
		break;
		case GAME_IS_COMPLETE_PROPERTY:
		game_set_is_complete (self, g_value_get_boolean (value));
		break;
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
		game_set_initial_number_of_tiles (self, g_value_get_uchar (value));
		break;
		case GAME_N_CURRENT_TILES_PROPERTY:
		game_set_n_current_tiles (self, g_value_get_uchar (value));
		break;
		case GAME_N_OPPONENT_TILES_PROPERTY:
		game_set_n_opponent_tiles (self, g_value_get_uchar (value));
		break;
		case GAME_ALTERNATIVE_START_PROPERTY:
		game_set_alternative_start (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

